wrf-python
==============

A collection of diagnostic and interpolation routines for use with output from the Weather Research and Forecasting (WRF-ARW) Model.

This package provides over 30 diagnostic calculations, several interpolation routines, and utilities to help with plotting via cartopy, basemap, or PyNGL. The functionality is similar to what is provided by the NCL WRF package.


Installation
----------------------------

    conda install -c conda-forge wrf-python

Documentation
----------------------------------

http://wrf-python.rtfd.org


Citation
------------------

    Ladwig, W. (2017). wrf-python (Version x.x.x) [Software]. Boulder, Colorado: UCAR/NCAR. https://doi.org/10.5065/D6W094P1 
    
Note: The version number x.x.x should be set to the version of wrf-python that you are using.


--------------------

*The National Center for Atmospheric Research is sponsored by the National
Science Foundation. Any opinions, findings and conclusions or recommendations
expressed in this material do not necessarily reflect the views of the
National Science Foundation.*

! NCLFORTSTART
SUBROUTINE DCOMPUTEWSPD(wspd, u, v, n)

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: wspd

    INTEGER, INTENT(IN) :: n
    REAL(KIND=8), DIMENSION(n), INTENT(OUT) :: wspd
    REAL(KIND=8), DIMENSION(n), INTENT(IN) :: u, v
! NCLEND

    INTEGER i

    !$OMP PARALLEL DO SCHEDULE(runtime)
    DO i = 1,n
        wspd(i) = SQRT(u(i)*u(i) + v(i)*v(i))
    END DO
    !$OMP END PARALLEL DO

END SUBROUTINE DCOMPUTEWSPD


! NCLFORTSTART
SUBROUTINE DCOMPUTEWDIR(wdir, u, v, n)
    USE wrf_constants, ONLY : DEG_PER_RAD

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: wdir

    INTEGER, INTENT(IN) :: n
    REAL(KIND=8), DIMENSION(n), INTENT(OUT) :: wdir
    REAL(KIND=8), DIMENSION(n), INTENT(IN) :: u, v
! NCLEND

    INTEGER i

    !$OMP PARALLEL DO SCHEDULE(runtime)
    DO i = 1,n
        wdir(i) = MOD(270.0 - ATAN2(v(i), u(i)) * DEG_PER_RAD, 360.)
    END DO
    !$OMP END PARALLEL DO

END SUBROUTINE DCOMPUTEWDIR

!NCLFORTSTART
SUBROUTINE ROTATECOORDS(ilat, ilon, olat, olon, lat_np, lon_np, lon_0, direction)
    USE wrf_constants, ONLY : PI, RAD_PER_DEG, DEG_PER_RAD

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: olat, olon

    REAL(KIND=8), INTENT(IN) :: ilat, ilon
    REAL(KIND=8), INTENT(OUT) :: olat, olon
    REAL(KIND=8), INTENT(IN) :: lat_np, lon_np, lon_0
    INTEGER, INTENT(IN) :: direction

! NCLFORTEND

    !  >=0, default : computational -> geographical
    !  < 0          : geographical  -> computational

    REAL(KIND=8) :: rlat, rlon
    REAL(KIND=8) :: phi_np, lam_np, lam_0, dlam
    REAL(KIND=8) :: sinphi, cosphi, coslam, sinlam
    !REAL(KIND=8), PARAMETER :: PI=3.141592653589793D0
    !REAL(KIND=8), PARAMETER :: RAD_PER_DEG=PI/180.D0
    !REAL(KIND=8), PARAMETER :: DEG_PER_RAD=180.D0/PI

    !convert all angles to radians
    phi_np = lat_np*RAD_PER_DEG
    lam_np = lon_np*RAD_PER_DEG
    lam_0 = lon_0*RAD_PER_DEG
    rlat = ilat*RAD_PER_DEG
    rlon = ilon*RAD_PER_DEG

    IF (direction .LT. 0) THEN
    ! the equations are exactly the same except for one
    ! small difference with respect to longitude ...
        dlam = pi - lam_0
    ELSE
        dlam = lam_np
    END IF

    sinphi = COS(phi_np)*COS(rlat)*COS(rlon - dlam) + SIN(phi_np)*SIN(rlat)
    cosphi = SQRT(1.D0 - sinphi*sinphi)
    coslam = SIN(phi_np)*COS(rlat)*COS(rlon - dlam) - COS(phi_np)*SIN(rlat)
    sinlam = COS(rlat)*SIN(rlon - dlam)

    IF (cosphi.NE.0.D0) THEN
        coslam = coslam/cosphi
        sinlam = sinlam/cosphi
    END IF

    olat = DEG_PER_RAD*ASIN(sinphi)
    olon = DEG_PER_RAD*(ATAN2(sinlam,coslam) - dlam - lam_0 + lam_np)

    RETURN

END SUBROUTINE ROTATECOORDS


!NCLFORTSTART
SUBROUTINE DLLTOIJ(map_proj, truelat1, truelat2, stdlon, lat1, lon1,&
                   pole_lat, pole_lon, knowni, knownj, dx, dy, latinc,&
                   loninc, lat, lon, loc, errstat, errmsg)
    USE wrf_constants, ONLY : ALGERR, PI, RAD_PER_DEG, DEG_PER_RAD, WRF_EARTH_RADIUS

    ! Converts input lat/lon values to the cartesian (i,j) value
    ! for the given projection.

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: loc


    INTEGER, INTENT(IN) :: map_proj
    REAL(KIND=8), INTENT(IN) :: stdlon
    REAL(KIND=8), INTENT(IN) ::lat1, lon1, pole_lat, pole_lon, knowni, knownj
    REAL(KIND=8), INTENT(IN) ::dx, dy, latinc, loninc
    REAL(KIND=8), INTENT(INOUT) :: lat, lon, truelat1, truelat2 ! these might get modified
    REAL(KIND=8), DIMENSION(2), INTENT(OUT) :: loc
    INTEGER, INTENT(INOUT) :: errstat
    CHARACTER(LEN=*), INTENT(INOUT) :: errmsg

!NCLEND

    REAL(KIND=8) :: deltalon1
    REAL(KIND=8) :: tl1r
    REAL(KIND=8) :: clain, dlon, rsw, deltalon, deltalat
    REAL(KIND=8) :: reflon, scale_top, ala1, alo1, ala, alo, rm, polei, polej
    ! earth radius divided by dx
    REAL(KIND=8) :: rebydx
    REAL(KIND=8) :: ctl1r, arg, cone, hemi
    REAL(KIND=8) :: i, j
    REAL(KIND=8) :: lat1n, lon1n, olat, olon

    ! Contants
    !REAL(KIND=8),PARAMETER :: PI=3.141592653589793D0
    !REAL(KIND=8),PARAMETER :: RAD_PER_DEG=PI/180.D0
    !REAL(KIND=8),PARAMETER :: DEG_PER_RAD=180.D0/PI
    !REAL(KIND=8),PARAMETER :: RE_M=6370000.D0 ! radius of earth in meters

    !      lat1     ! sw latitude (1,1) in degrees (-90->90n)
    !      lon1     ! sw longitude (1,1) in degrees (-180->180e)
    !      dx       ! grid spacing in meters at truelats
    !      dlat     ! lat increment for lat/lon grids
    !      dlon     ! lon increment for lat/lon grids
    !      stdlon   ! longitude parallel to y-axis (-180->180e)
    !      truelat1 ! first true latitude (all projections)
    !      truelat2 ! second true lat (lc only)
    !      hemi     ! 1 for nh, -1 for sh
    !      cone     ! cone factor for lc projections
    !      polei    ! computed i-location of pole point
    !      polej    ! computed j-location of pole point
    !      rsw      ! computed radius to sw corner
    !      knowni   ! x-location of known lat/lon
    !      knownj   ! y-location of known lat/lon
    !      re_m     ! radius of spherical earth, meters
    !      rebydx   ! earth radius divided by dx

    errstat = INT(dy) ! remove compiler warning since dy not used
    errstat = 0

    rebydx = WRF_EARTH_RADIUS/dx

    ! Get rid of compiler warnings
    i=0
    j=0

    hemi = 1.0D0
    IF (truelat1 .LT. 0.0D0) THEN
        hemi = -1.0D0
    END IF

    ! mercator
    IF (map_proj.EQ.3) THEN

        ! preliminary variables
        clain = COS(RAD_PER_DEG*truelat1)
        dlon = dx/(WRF_EARTH_RADIUS*clain)

        ! compute distance from equator to origin, and store in
        ! the rsw tag.
        rsw = 0.D0
        IF (lat1 .NE. 0.D0) THEN
            rsw = (LOG(TAN(0.5D0*((lat1 + 90.D0)*RAD_PER_DEG))))/dlon
        END IF

        deltalon = lon - lon1
        IF (deltalon .LT. -180.D0) deltalon = deltalon + 360.D0
        IF (deltalon .GT. 180.D0) deltalon = deltalon - 360.D0
        i = knowni + (deltalon/(dlon*DEG_PER_RAD))
        j = knownj + (LOG(TAN(0.5D0*((lat + 90.D0)*RAD_PER_DEG))))/dlon - rsw

    ! ps
    ELSE IF (map_proj .EQ. 2) THEN

        reflon = stdlon + 90.D0

        ! compute numerator term of map scale factor
        scale_top = 1.D0 + hemi*SIN(truelat1*RAD_PER_DEG)

        ! compute radius to lower-left (sw) corner
        ala1 = lat1*RAD_PER_DEG
        rsw = rebydx*COS(ala1)*scale_top/(1.D0 + hemi*SIN(ala1))

        ! find the pole point
        alo1 = (lon1 - reflon)*RAD_PER_DEG
        polei = knowni - rsw*COS(alo1)
        polej = knownj - hemi*rsw*SIN(alo1)

        ! find radius to desired point
        ala = lat*RAD_PER_DEG
        rm = rebydx*COS(ala)*scale_top/(1.D0 + hemi*SIN(ala))
        alo = (lon - reflon)*RAD_PER_DEG
        i = polei + rm*COS(alo)
        j = polej + hemi*rm*SIN(alo)

    ! lambert
    ELSE IF (map_proj .EQ. 1) THEN

        IF (ABS(truelat2) .GT. 90.D0) THEN
            truelat2 = truelat1
        END IF

        IF (ABS(truelat1 - truelat2) .GT. 0.1D0) THEN
            cone = (LOG(COS(truelat1*RAD_PER_DEG))-LOG(COS(truelat2*RAD_PER_DEG)))/&
                 (LOG(TAN((90.D0 - ABS(truelat1))*RAD_PER_DEG*0.5D0))-&
                 LOG(TAN((90.D0 - ABS(truelat2))*RAD_PER_DEG*0.5D0)))
        ELSE
            cone = SIN(ABS(truelat1)*RAD_PER_DEG)
        END IF

        ! compute longitude differences and ensure we stay
        ! out of the forbidden "cut zone"
        deltalon1 = lon1 - stdlon
        IF (deltalon1 .GT. +180.D0) deltalon1 = deltalon1 - 360.D0
        IF (deltalon1 .LT. -180.D0) deltalon1 = deltalon1 + 360.D0

        ! convert truelat1 to radian and compute cos for later use
        tl1r = truelat1*RAD_PER_DEG
        ctl1r = COS(tl1r)

        ! compute the radius to our known lower-left (sw) corner
        rsw = rebydx*ctl1r/cone*(TAN((90.D0*hemi - lat1)*RAD_PER_DEG/2.D0)/&
            TAN((90.D0*hemi - truelat1)*RAD_PER_DEG/2.D0))**cone

        ! find pole point
        arg = cone*(deltalon1*RAD_PER_DEG)
        polei = hemi*knowni - hemi*rsw*SIN(arg)
        polej = hemi*knownj + rsw*COS(arg)

        ! compute deltalon between known longitude and standard
        ! lon and ensure it is not in the cut zone
        deltalon = lon - stdlon
        IF (deltalon .GT. +180.D0) deltalon = deltalon - 360.D0
        IF (deltalon .LT. -180.D0) deltalon = deltalon + 360.D0

        ! radius to desired point
        rm = rebydx*ctl1r/cone*(TAN((90.D0*hemi - lat)*RAD_PER_DEG/2.D0)/&
                  TAN((90.D0*hemi - truelat1)*RAD_PER_DEG/2.D0))**cone

        arg = cone*(deltalon*RAD_PER_DEG)
        i = polei + hemi*rm*SIN(arg)
        j = polej - rm*COS(arg)

        ! finally, if we are in the southern hemisphere, flip the
        ! i/j values to a coordinate system where (1,1) is the sw
        ! corner (what we assume) which is different than the
        ! original ncep algorithms which used the ne corner as
        ! the origin in the southern hemisphere (left-hand vs.
        ! right-hand coordinate?)
        i = hemi*i
        j = hemi*j

    ! lat-lon
    ELSE IF (map_proj .EQ. 6) THEN

        IF (pole_lat .NE. 90.D0) THEN
            CALL ROTATECOORDS(lat, lon, olat, olon, pole_lat, pole_lon, stdlon, -1)
            lat = olat
            lon = olon + stdlon
        END IF

        ! make sure center lat/lon is good
        IF (pole_lat .NE. 90.D0) THEN
            CALL ROTATECOORDS(lat1, lon1, olat, olon, pole_lat, pole_lon, stdlon, -1)
            lat1n = olat
            lon1n = olon + stdlon
            deltalat = lat - lat1n
            deltalon = lon - lon1n
        ELSE
            deltalat = lat - lat1
            deltalon = lon - lon1
        END IF

        ! compute i/j
        i = deltalon/loninc
        j = deltalat/latinc

        i = i + knowni
        j = j + knownj

    ELSE
        errstat = ALGERR
        WRITE(errmsg, *) "Do not know map projection ", map_proj
        RETURN
    END IF

    loc(1) = j
    loc(2) = i

    RETURN

END SUBROUTINE DLLTOIJ


!NCLFORTSTART
SUBROUTINE DIJTOLL(map_proj, truelat1, truelat2, stdlon, lat1, lon1,&
                   pole_lat, pole_lon, knowni, knownj, dx, dy, latinc,&
                   loninc, ai, aj, loc, errstat, errmsg)
    USE wrf_constants, ONLY : ALGERR, PI, RAD_PER_DEG, DEG_PER_RAD, WRF_EARTH_RADIUS

    ! converts input lat/lon values to the cartesian (i,j) value
    ! for the given projection.
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: loc

    INTEGER, INTENT(IN) :: map_proj
    REAL(KIND=8), INTENT(IN) :: stdlon
    REAL(KIND=8), INTENT(IN) :: lat1, lon1, pole_lat, pole_lon, knowni, knownj
    REAL(KIND=8), INTENT(IN) :: dx, dy, latinc, loninc, ai, aj
    REAL(KIND=8), INTENT(INOUT) :: truelat1, truelat2
    REAL(KIND=8), DIMENSION(2), INTENT(OUT) :: loc
    INTEGER, INTENT(INOUT) :: errstat
    CHARACTER(LEN=*), INTENT(INOUT) :: errmsg

!NCLEND

    REAL(KIND=8) :: gi2
    REAL(KIND=8) :: arccos
    REAL(KIND=8) :: deltalon1
    REAL(KIND=8) :: tl1r
    REAL(KIND=8) :: clain, dlon, rsw, deltalon, deltalat
    REAL(KIND=8) :: reflon, scale_top, ala1, alo1, polei, polej
    ! earth radius divided by dx
    REAL(KIND=8) :: rebydx
    REAL(KIND=8) :: ctl1r, cone, hemi

    !REAL(KIND=8),PARAMETER :: PI = 3.141592653589793D0
    !REAL(KIND=8),PARAMETER :: RAD_PER_DEG = PI/180.D0
    !REAL(KIND=8),PARAMETER :: DEG_PER_RAD = 180.D0/PI
    !REAL(KIND=8),PARAMETER :: RE_M = 6370000.D0 ! radius of sperical earth

    REAL(KIND=8) :: inew, jnew, r, r2
    REAL(KIND=8) :: chi, chi1, chi2
    REAL(KIND=8) :: xx, yy, lat, lon

    REAL(KIND=8) :: olat, olon, lat1n, lon1n


    !     lat1     ! sw latitude (1,1) in degrees (-90->90n)
    !     lon1     ! sw longitude (1,1) in degrees (-180->180e)
    !     dx       ! grid spacing in meters at truelats
    !     dlat     ! lat increment for lat/lon grids
    !     dlon     ! lon increment for lat/lon grids
    !     stdlon   ! longitude parallel to y-axis (-180->180e)
    !     truelat1 ! first true latitude (all projections)
    !     truelat2 ! second true lat (lc only)
    !     hemi     ! 1 for nh, -1 for sh
    !     cone     ! cone factor for lc projections
    !     polei    ! computed i-location of pole point
    !     polej    ! computed j-location of pole point
    !     rsw      ! computed radius to sw corner
    !     knowni   ! x-location of known lat/lon
    !     knownj   ! y-location of known lat/lon
    !     re_m     ! radius of spherical earth, meters
    !     rebydx   ! earth radius divided by dx

    errstat = INT(dy) ! Remove compiler warning since dy not used
    errstat = 0

    rebydx = WRF_EARTH_RADIUS/dx

    hemi = 1.0D0
    IF (truelat1 .LT. 0.0D0) THEN
        hemi = -1.0D0
    END IF

    ! mercator
    IF (map_proj .EQ. 3) THEN
        ! preliminary variables
        clain = COS(RAD_PER_DEG*truelat1)
        dlon = dx/(WRF_EARTH_RADIUS*clain)

        ! compute distance from equator to origin, and store in
        ! the rsw tag.
        rsw = 0.D0
        IF (lat1 .NE. 0.D0) THEN
            rsw = (LOG(TAN(0.5D0*((lat1 + 90.D0)*RAD_PER_DEG))))/dlon
        END IF

        lat = 2.0D0*ATAN(EXP(dlon*(rsw + aj - knownj)))*DEG_PER_RAD - 90.D0
        lon = (ai - knowni)*dlon*DEG_PER_RAD + lon1
        IF (lon .GT. 180.D0) lon = lon - 360.D0
        IF (lon .LT. -180.D0) lon = lon + 360.D0

        ! ps
    ELSE IF (map_proj .EQ. 2) THEN

        ! compute the reference longitude by rotating 90 degrees to
        ! the east to find the longitude line parallel to the
        ! positive x-axis.
        reflon = stdlon + 90.D0

        ! compute numerator term of map scale factor
        scale_top = 1.D0 + hemi*SIN(truelat1*RAD_PER_DEG)

        ! compute radius to known point
        ala1 = lat1*RAD_PER_DEG
        rsw = rebydx*COS(ala1)*scale_top/(1.D0 + hemi*SIN(ala1))

        ! find the pole point
        alo1 = (lon1 - reflon)*RAD_PER_DEG
        polei = knowni - rsw*COS(alo1)
        polej = knownj - hemi*rsw*SIN(alo1)

        ! compute radius to point of interest
        xx = ai - polei
        yy = (aj - polej)*hemi
        r2 = xx**2 + yy**2

        ! now the magic code
        IF (r2 .EQ. 0.D0) THEN
            lat = hemi*90.D0
            lon = reflon
        ELSE
            gi2 = (rebydx*scale_top)**2.D0
            lat = DEG_PER_RAD*hemi*ASIN((gi2 - r2)/(gi2 + r2))
            arccos = ACOS(xx/SQRT(r2))
            IF (yy .GT. 0) THEN
                lon = reflon + DEG_PER_RAD*arccos
            ELSE
                lon = reflon - DEG_PER_RAD*arccos
            END IF
      END IF

        ! convert to a -180 -> 180 east convention
        IF (lon .GT. 180.D0) lon = lon - 360.D0
        IF (lon .LT. -180.D0) lon = lon + 360.D0

    !     !lambert
    ELSE IF (map_proj .EQ. 1) THEN

        IF (ABS(truelat2) .GT. 90.D0) THEN
            truelat2 = truelat1
        END IF

        IF (ABS(truelat1 - truelat2) .GT. 0.1D0) THEN
            cone = (LOG(COS(truelat1*RAD_PER_DEG)) - LOG(COS(truelat2*RAD_PER_DEG)))/&
                 (LOG(TAN((90.D0 - ABS(truelat1))*RAD_PER_DEG*0.5D0)) - &
                  LOG(TAN((90.D0 - ABS(truelat2))*RAD_PER_DEG*0.5D0)))
        ELSE
            cone = SIN(ABS(truelat1)*RAD_PER_DEG)
        END IF

        ! compute longitude differences and ensure we stay out of the
        ! forbidden "cut zone"
        deltalon1 = lon1 - stdlon
        IF (deltalon1 .GT. +180.D0) deltalon1 = deltalon1 - 360.D0
        IF (deltalon1 .LT. -180.D0) deltalon1 = deltalon1 + 360.D0

        ! convert truelat1 to radian and compute cos for later use
        tl1r = truelat1*RAD_PER_DEG
        ctl1r = COS(tl1r)

        ! compute the radius to our known point
        rsw = rebydx*ctl1r/cone*(TAN((90.D0*hemi - lat1)*RAD_PER_DEG/2.D0)/&
                         TAN((90.D0*hemi - truelat1)*RAD_PER_DEG/2.D0))**cone

        ! find pole point
        alo1 = cone*(deltalon1*RAD_PER_DEG)
        polei = hemi*knowni - hemi*rsw*SIN(alo1)
        polej = hemi*knownj + rsw*COS(alo1)

        chi1 = (90.D0 - hemi*truelat1)*RAD_PER_DEG
        chi2 = (90.D0 - hemi*truelat2)*RAD_PER_DEG

        ! see if we are in the southern hemispere and flip the
        ! indices if we are.
        inew = hemi*ai
        jnew = hemi*aj

        ! compute radius**2 to i/j location
        reflon = stdlon + 90.D0
        xx = inew - polei
        yy = polej - jnew
        r2 = (xx*xx + yy*yy)
        r = sqrt(r2)/rebydx

        ! convert to lat/lon
        IF (r2 .EQ. 0.D0) THEN
            lat = hemi*90.D0
            lon = stdlon
        ELSE
            lon = stdlon + DEG_PER_RAD*ATAN2(hemi*xx,yy)/cone
            lon = dmod(lon + 360.D0, 360.D0)
            IF (chi1 .EQ. chi2) THEN
                chi = 2.0D0*ATAN((r/TAN(chi1))**(1.D0/cone)*TAN(chi1*0.5D0))
            ELSE
                chi = 2.0D0*ATAN((r*cone/SIN(chi1))**(1.D0/cone)*TAN(chi1*0.5D0))
            END IF
            lat = (90.0D0 - chi*DEG_PER_RAD)*hemi
        END IF

        IF (lon .GT. +180.D0) lon = lon - 360.D0
        IF (lon .LT. -180.D0) lon = lon + 360.D0

    !     !lat-lon
    ELSE IF (map_proj .EQ. 6) THEN
        inew = ai - knowni
        jnew = aj - knownj

        IF (inew .LT. 0.D0) inew = inew + 360.D0/loninc
        IF (inew .GE. 360.D0/dx) inew = inew - 360.D0/loninc

        ! compute deltalat and deltalon
        deltalat = jnew*latinc
        deltalon = inew*loninc

        IF (pole_lat .NE. 90.D0) THEN
            CALL ROTATECOORDS(lat1, lon1, olat, olon, pole_lat, pole_lon, stdlon, -1)
            lat1n = olat
            lon1n = olon + stdlon
            lat = deltalat + lat1n
            lon = deltalon + lon1n
        ELSE
            lat = deltalat + lat1
            lon = deltalon + lon1
        END IF

        IF (pole_lat .NE. 90.D0) THEN
            lon = lon - stdlon
            CALL ROTATECOORDS(lat, lon, olat, olon, pole_lat, pole_lon, stdlon, 1)
            lat = olat
            lon = olon
        END IF

        IF (lon .LT. -180.D0) lon = lon + 360.D0
        IF (lon .GT. 180.D0) lon = lon - 360.D0

    ELSE
        errstat = ALGERR
        WRITE(errmsg, *) "Do not know map projection ", map_proj
        RETURN
    END IF

    loc(1) = lat
    loc(2) = lon

    RETURN

END SUBROUTINE DIJTOLL

!======================================================================
!
! !IROUTINE: WETBULBCALC -- Calculate wet bulb temperature (C)
!
! !DESCRIPTION:
!
!   Calculates wet bulb temperature in C, given pressure in
!      temperature in K and mixing ratio in kg/kg.
!
! !INPUT:
!    nx     - index for x dimension
!    ny     - index for y dimension
!    nz     - index for z dimension
!    prs    - pressure (mb)
!    tmk    - temperature (K)
!    qvp    - water vapor mixing ratio (kg/kg)
!
! !OUTPUT:
!    twb    - Wet bulb temperature (C)
!
! !ASSUMPTIONS:
!
! !REVISION HISTORY:
!     2009-March  - Mark T. Stoelinga - from RIP4.5
!     2010-August - J. Schramm
!     2014-March - A. Jaye - modified to run with NCL and ARW wrf output
!
! !INTERFACE:
! ------------------------------------------------------------------

! NCLFORTSTART
SUBROUTINE WETBULBCALC(prs, tmk, qvp, twb, nx, ny, nz, psafile, errstat, errmsg)
    USE wrf_constants, ONLY : ALGERR, GAMMA, GAMMAMD, TLCLC1, TLCLC2, TLCLC3, &
                          EPS, TLCLC4, THTECON1, THTECON2, THTECON3

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: twb

    INTEGER, INTENT(IN) :: nx, ny, nz
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: prs
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: tmk
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: qvp
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(OUT) :: twb
    CHARACTER(LEN=*), INTENT(IN) :: psafile
    INTEGER, INTENT(INOUT) :: errstat
    CHARACTER(LEN=*), INTENT(INOUT) :: errmsg

!NCLEND

    INTEGER :: i, j, k
    INTEGER :: jt, ip
    REAL(KIND=8) :: q, t, p, e, tlcl, eth
    REAL(KIND=8) :: fracip, fracip2, fracjt, fracjt2
    REAL(KIND=8), DIMENSION(150) :: PSADITHTE, PSADIPRS
    REAL(KIND=8), DIMENSION(150,150) :: PSADITMK
    REAL(KIND=8) :: tonpsadiabat

    INTEGER :: l1, h1, mid1, rang1, l2, h2, mid2, rang2
    INTEGER :: errcnt1, errcnt2, bad_i, bad_j, bad_k
    REAL(KIND=8) :: bad_p, bad_eth
    !INTEGER :: ip, ipch, jt, jtch

    errcnt1 = 0
    errcnt2 = 0
    bad_i = -1
    bad_j = -1
    bad_k = -1

    !  Before looping, set lookup table for getting temperature on
    !  a pseudoadiabat.

    CALL DLOOKUP_TABLE(PSADITHTE, PSADIPRS, PSADITMK, psafile, errstat, errmsg)

    IF (errstat .NE. 0) THEN
        RETURN
    END IF

    !$OMP PARALLEL DO COLLAPSE(3) PRIVATE (i, j, k, jt, ip, q, t, p, e, tlcl, &
    !$OMP eth, fracip, fracip2, fracjt, fracjt2, l1, h1, mid1, rang1, l2, h2, &
    !$OMP mid2, rang2, tonpsadiabat) REDUCTION(+:errcnt1, errcnt2) &
    !$OMP SCHEDULE(runtime)
    DO k=1,nz
        DO j=1,ny
            DO i=1,nx
                q = MAX(qvp(i,j,k), 1.D-15)
                t = tmk(i,j,k)
                p = prs(i,j,k)/100.
                e = q*p/(EPS + q)
                tlcl = TLCLC1/(LOG(t**TLCLC2/e) - TLCLC3) + TLCLC4
                eth = t*(1000./p)**(GAMMA*(1. + GAMMAMD*q))*&
                    EXP((THTECON1/tlcl - THTECON2)*q*(1. + THTECON3*q))

                ! Now we need to find the temperature (in K) on a moist adiabat
                ! (specified by eth in K) given pressure in hPa.  It uses a
                ! lookup table, with data that was generated by the Bolton (1980)
                ! formula for theta_e.

                ! First check if pressure is less than min pressure in lookup table.
                ! If it is, assume parcel is so dry that the given theta-e value can
                ! be interpretted as theta, and get temperature from the simple dry
                ! theta formula.

                IF (p .LE. PSADIPRS(150)) THEN
                    tonpsadiabat = eth*(p/1000.)**GAMMA
                ELSE
                    ! Otherwise, look for the given thte/prs point in the lookup table.
                    jt = -1
                    l1 = 1
                    h1 = 149
                    rang1 = h1 - l1
                    mid1 = (h1 + l1) / 2
                    DO WHILE(rang1 .GT. 1)
                        IF (eth .GE. psadithte(mid1)) THEN
                             l1 = mid1
                        ELSE
                             h1 = mid1
                        END IF
                        rang1 = h1 - l1
                        mid1 = (h1 + l1) / 2
                    END DO
                    jt = l1

                    ip = -1
                    l2 = 1
                    h2 = 149
                    rang2 = h2 - l2
                    mid2 = (h2 + l2) / 2
                    DO WHILE(rang2 .GT. 1)
                        IF (p .LE. psadiprs(mid2)) THEN
                            l2 = mid2
                        ELSE
                            h2 = mid2
                        END IF
                        rang2 = h2 - l2
                        mid2 = (h2 + l2) / 2
                    END DO
                    ip = l2

                    IF (jt .EQ. -1 .OR. ip .EQ. -1) THEN
                        errcnt1 = errcnt1 + 1
                        !$OMP CRITICAL
                        ! Only do this the first time
                        IF (bad_i .EQ. -1) THEN
                            bad_i = i
                            bad_j = j
                            bad_k = k
                            bad_p = p
                            bad_eth = eth
                        END IF
                        !$OMP END CRITICAL
                        CYCLE
                    ENDIF

                    fracjt = (eth - PSADITHTE(jt))/(PSADITHTE(jt+1) - PSADITHTE(jt))
                    fracjt2 = 1. - fracjt
                    fracip = (PSADIPRS(ip) - p)/(PSADIPRS(ip) - PSADIPRS(ip+1))
                    fracip2 = 1. - fracip


                    IF (PSADITMK(ip,jt) .GT. 1e9 .OR. PSADITMK(ip+1,jt) .GT. 1e9 .OR. &
                        PSADITMK(ip,jt+1) .GT. 1e9 .OR. PSADITMK(ip+1,jt+1) .GT. 1e9) THEN
                        errcnt2 = errcnt2 + 1
                        !$OMP CRITICAL
                        ! Only do this the first time
                        IF (bad_i .EQ. -1) THEN
                            bad_i = i
                            bad_j = j
                            bad_k = k
                            bad_p = p
                            bad_eth = eth
                        END IF
                        !$OMP END CRITICAL
                        CYCLE
                    ENDIF

                    tonpsadiabat = fracip2*fracjt2*PSADITMK(ip,jt) + &
                                   fracip*fracjt2*PSADITMK(ip+1,jt) + &
                                   fracip2*fracjt*PSADITMK(ip,jt+1) + &
                                   fracip*fracjt*PSADITMK(ip+1,jt+1)
                ENDIF

                twb(i,j,k) = tonpsadiabat

            END DO
        END DO
    END DO

    !$OMP END PARALLEL DO

    IF (errcnt1 > 0) THEN
        errstat = ALGERR
        WRITE(errmsg, *) "Outside of lookup table bounds. i=", bad_i, ",j=", bad_j, ",k=", bad_k, ",p=", bad_p, ",eth=", bad_eth
        RETURN
    END IF

    IF (errcnt2 > 0) THEN
        errstat = ALGERR
        WRITE(errmsg, *) "PRS and THTE unreasonable. i=", bad_i, ",j=", bad_j, ",k=", bad_k, ",p=", bad_p, ",eth=", bad_eth
        RETURN
    END IF

    RETURN

END SUBROUTINE WETBULBCALC


! !IROUTINE: omgcalc -- Calculate omega (dp/dt)
!
! !DESCRIPTION:
!
!   Calculate approximate omega, based on vertical velocity w (dz/dt).
!   It is approximate because it cannot take into account the vertical
!   motion of pressure surfaces.
!
! !INPUT:
!    mx - index for x dimension
!    my - index for y dimension
!    mx -  index for vertical dimension
!    qvp - water vapor mixing ratio (kg/kg)
!    tmk - temperature (K)
!    www - vertical velocity (m/s)
!    prs -  pressure (Pa)
!
! !OUTPUT:
!    omg - omega (Pa/sec)
!
! !ASSUMPTIONS:
!
! !REVISION HISTORY:
!     2009-March  - Mark T. Stoelinga - from RIP4.5
!     2010-August - J. Schramm
!     2014-March - A. Jaye - modified to run with NCL and ARW wrf output
!
! ------------------------------------------------------------------

!NCLFORTSTART
SUBROUTINE OMGCALC(qvp, tmk, www, prs, omg, mx, my, mz)
    USE wrf_constants, ONLY : G, RD, EPS

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: omg

    INTEGER,INTENT(IN) :: mx, my, mz
    REAL(KIND=8), INTENT(IN), DIMENSION(mx,my,mz) :: qvp
    REAL(KIND=8), INTENT(IN), DIMENSION(mx,my,mz) :: tmk
    REAL(KIND=8), INTENT(IN), DIMENSION(mx,my,mz) :: www
    REAL(KIND=8), INTENT(IN), DIMENSION(mx,my,mz) :: prs
    REAL(KIND=8), INTENT(OUT), DIMENSION(mx,my,mz) :: omg

!NCLEND

    ! Local variables
    INTEGER :: i, j, k
    !REAL(KIND=8), PARAMETER :: GRAV=9.81, RGAS=287.04, EPS=0.622

    !$OMP PARALLEL DO COLLAPSE(3) SCHEDULE(runtime)
    DO k=1,mz
        DO j=1,my
            DO i=1,mx
                omg(i,j,k) = -G*prs(i,j,k)/&
                              (RD*((tmk(i,j,k)*(EPS + qvp(i,j,k)))/&
                              (EPS*(1. + qvp(i,j,k)))))*www(i,j,k)
            END DO
       END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE OMGCALC

!======================================================================
!
! !IROUTINE: VIRTUAL_TEMP -- Calculate virtual temperature (K)
!
! !DESCRIPTION:
!
!   Calculates virtual temperature in K, given temperature
!      in K and mixing ratio in kg/kg.
!
! !INPUT:
!    NX     - index for x dimension
!    NY     - index for y dimension
!    NZ     - index for z dimension
!    RATMIX - water vapor mixing ratio (kg/kg)
!    TEMP   - temperature (K)
!
! !OUTPUT:
!    TV     - Virtual temperature (K)
!
! !ASSUMPTIONS:
!
! !REVISION HISTORY:
!     2009-March  - Mark T. Stoelinga - from RIP4.5
!     2010-August - J. Schramm
!     2014-March - A. Jaye - modified to run with NCL and ARW wrf output
!
! ------------------------------------------------------------------
!NCLFORTSTART
SUBROUTINE VIRTUAL_TEMP(temp, ratmix, tv, nx, ny, nz)
    USE wrf_constants, ONLY : EPS

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: tv

    INTEGER, INTENT(IN) :: nx, ny, nz
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: temp
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: ratmix
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(OUT) :: tv

!NCLEND

    INTEGER :: i,j,k
    !REAL(KIND=8),PARAMETER :: EPS = 0.622D0

    !$OMP PARALLEL DO COLLAPSE(3) SCHEDULE(runtime)
    DO k=1,nz
        DO j=1,ny
            DO i=1,nx
                tv(i,j,k) = temp(i,j,k)*(EPS + ratmix(i,j,k))/(EPS*(1.D0 + ratmix(i,j,k)))
            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE VIRTUAL_TEMP

! NCLFORTSTART
SUBROUTINE DCLOUDFRAC(pres, rh, lowc, midc, highc, nz, ns, ew)
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: lowc, midc, highc

    INTEGER  nz, ns, ew
    REAL(KIND=8), DIMENSION(ew, ns, nz), INTENT(IN) :: pres, rh
    REAL(KIND=8), DIMENSION(ew, ns), INTENT(OUT) :: lowc, midc, highc

! NCLEND

    INTEGER i, j, k
    INTEGER kchi, kcmi, kclo

    ! Remove compiler warnings
    kchi = 0
    kcmi = 0
    kclo = 0
    lowc = 0
    midc = 0
    highc = 0

    !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(i, j, k, kchi, kcmi, kclo) &
    !$OMP SCHEDULE(runtime)
    DO j = 1,ns
        DO i = 1,ew
            DO k = 1,nz-1
                IF ( pres(i,j,k) .GT. 97000. ) kclo=k
                IF ( pres(i,j,k) .GT. 80000. ) kcmi=k
                IF ( pres(i,j,k) .GT. 45000. ) kchi=k
            END DO

            DO k = 1,nz-1
                IF (k .GE. kclo .AND. k .LT. kcmi) THEN
                    lowc(i,j) = MAX(rh(i,j,k), lowc(i,j))
                ELSE IF (k .GE. kcmi .AND. k .LT. kchi) THEN ! mid cloud
                    midc(i,j) = MAX(rh(i,j,k), midc(i,j))
                ELSE if (k .GE. kchi) THEN                  ! high cloud
                    highc(i,j) = MAX(rh(i,j,k), highc(i,j))
                END IF
            END DO

            lowc(i,j)  = 4.0*lowc(i,j)/100. - 3.0
            midc(i,j)  = 4.0*midc(i,j)/100. - 3.0
            highc(i,j) = 2.5*highc(i,j)/100. - 1.5

            lowc(i,j)  = MIN(lowc(i,j), 1.0)
            lowc(i,j)  = MAX(lowc(i,j), 0.0)
            midc(i,j)  = MIN(midc(i,j), 1.0)
            midc(i,j)  = MAX(midc(i,j), 0.0)
            highc(i,j) = MIN(highc(i,j), 1.0)
            highc(i,j) = MAX(highc(i,j), 0.0)

       END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DCLOUDFRAC


! NCLFORTSTART
SUBROUTINE DCLOUDFRAC2(vert, rh, vert_inc_w_height, low_thresh, mid_thresh, &
                       high_thresh, msg, lowc, midc, highc, nz, ns, ew)
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: lowc, midc, highc

    INTEGER  nz, ns, ew
    REAL(KIND=8), DIMENSION(ew, ns, nz), INTENT(IN) :: rh, vert
    REAL(KIND=8), INTENT(IN) :: low_thresh, mid_thresh, high_thresh, msg
    INTEGER, INTENT(IN) :: vert_inc_w_height
    REAL(KIND=8), DIMENSION(ew, ns), INTENT(OUT) :: lowc, midc, highc

! NCLEND

    INTEGER i, j, k
    INTEGER kchi, kcmi, kclo

    ! Initialize the output
    lowc = 0
    midc = 0
    highc = 0

    !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(i, j, k, kchi, kcmi, kclo) &
    !$OMP SCHEDULE(runtime)
    DO j = 1,ns
        DO i = 1,ew
            ! A value of -1 means 'not found'.  This is needed to handle
            ! the mountains, where the level thresholds are below the lowest
            ! model level.
            kchi = -1
            kcmi = -1
            kclo = -1

            IF (vert_inc_w_height .NE. 0) THEN ! Vert coord increase with height
                DO k = 1,nz
                    IF (vert(i,j,k) .LT. low_thresh) kclo=k
                    IF (vert(i,j,k) .LT. mid_thresh) kcmi=k
                    IF (vert(i,j,k) .LT. high_thresh) kchi=k
                END DO
            ELSE ! Vert coord decrease with height
                DO k = 1,nz
                    IF (vert(i,j,k) .GT. low_thresh) kclo=k
                    IF (vert(i,j,k) .GT. mid_thresh) kcmi=k
                    IF (vert(i,j,k) .GT. high_thresh) kchi=k
                END DO
            ENDIF

            DO k = 1,nz
                IF (k .GE. kclo .AND. k .LT. kcmi) THEN
                    lowc(i,j) = MAX(rh(i,j,k), lowc(i,j))
                ELSE IF (k .GE. kcmi .AND. k .LT. kchi) THEN ! mid cloud
                    midc(i,j) = MAX(rh(i,j,k), midc(i,j))
                ELSE if (k .GE. kchi) THEN                  ! high cloud
                    highc(i,j) = MAX(rh(i,j,k), highc(i,j))
                END IF
            END DO

            ! Only do this when a cloud threshold is in the model vertical
            ! domain, otherwise it will be set to missing
            IF (kclo .GE. 1) THEN
                lowc(i,j)  = 4.0*lowc(i,j)/100. - 3.0
                lowc(i,j)  = MIN(lowc(i,j), 1.0)
                lowc(i,j)  = MAX(lowc(i,j), 0.0)
            ELSE
                lowc(i,j) = msg
            END IF

            IF (kcmi .GE. 1) THEN
                midc(i,j)  = 4.0*midc(i,j)/100. - 3.0
                midc(i,j)  = MIN(midc(i,j), 1.0)
                midc(i,j)  = MAX(midc(i,j), 0.0)
            ELSE
                midc(i,j) = msg
            END IF

            IF (kchi .GE. 1) THEN
                highc(i,j) = 2.5*highc(i,j)/100. - 1.5
                highc(i,j) = MIN(highc(i,j), 1.0)
                highc(i,j) = MAX(highc(i,j), 0.0)
            ELSE
                highc(i,j) = msg
            END IF

       END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DCLOUDFRAC2

!##################################################################
!##################################################################
!######                                                      ######
!######                  SUBROUTINE CALC_UH                  ######
!######                                                      ######
!######                     Developed by                     ######
!######     Center for Analysis and Prediction of Storms     ######
!######                University of Oklahoma                ######
!######                                                      ######
!##################################################################
!##################################################################
!
!  Calculates updraft helicity (UH) to detect rotating updrafts.
!  Formula follows Kain et al, 2008, Wea. and Forecasting, 931-952,
!  but this version has controls for the limits of integration
!  uhminhgt to uhmxhgt, in m AGL.  Kain et al used 2000 to 5000 m.
!  Units of UH are m^2/s^2.
!
!  Note here that us and vs are at ARPS scalar points.
!  w is at w-point (scalar pt in horiz, staggered vertical)
!
!  Keith Brewster, CAPS/Univ. of Oklahoma
!  March, 2010

!NCLFORTSTART
SUBROUTINE DCALCUH(nx, ny, nz, nzp1, zp, mapfct, dx, dy, uhmnhgt, uhmxhgt, us, &
                   vs, w, uh, tem1, tem2)

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: uh

    INTEGER, INTENT(IN) :: nx, ny, nz, nzp1
    REAL(KIND=8), DIMENSION(nx,ny,nzp1), INTENT(IN)  :: zp
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(IN) :: mapfct
    REAL(KIND=8), INTENT(IN) :: dx, dy
    REAL(KIND=8), INTENT(IN) :: uhmnhgt, uhmxhgt
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN)  :: us
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN)  :: vs
    REAL(KIND=8), DIMENSION(nx,ny,nzp1), INTENT(IN)  :: w
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(OUT) :: uh
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(INOUT) :: tem1
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(INOUT) :: tem2

!NCLEND

    ! Misc local variables
    INTEGER :: i, j, k, kbot, ktop
    REAL(KIND=8) :: twodx, twody, wgtlw, sum, wmean, wsum !,wavg
    REAL(KIND=8) :: helbot, heltop, wbot, wtop
    REAL(KIND=8) :: zbot, ztop

    ! Initialize arrays
    uh = 0.0
    tem1 = 0.0

    ! Calculate vertical component of helicity at scalar points
    !   us: u at scalar points
    !   vs: v at scalar points

    twodx = 2.0*dx
    twody = 2.0*dy

    !$OMP PARALLEL

    !$OMP DO COLLAPSE(3) SCHEDULE(runtime)
    DO k=2,nz-2
        DO j=2,ny-1
            DO i=2,nx-1
                !wavg = 0.5*(w(i,j,k)+w(i,j,k+1))
                tem1(i,j,k) = (0.5*(w(i,j,k)+w(i,j,k+1)))*((vs(i+1,j,k) - &
                              vs(i-1,j,k))/(twodx*mapfct(i,j)) - &
                              (us(i,j+1,k) - us(i,j-1,k))/(twody*mapfct(i,j)))
                tem2(i,j,k) = 0.5*(zp(i,j,k) + zp(i,j,k+1))
            END DO
        END DO
    END DO
    !$OMP END DO

    ! Integrate over depth uhminhgt to uhmxhgt AGL
    !
    !  WRITE(6,'(a,f12.1,a,f12.1,a)') &
    !        'Calculating UH from ',uhmnhgt,' to ',uhmxhgt,' m AGL'
    !$OMP DO COLLAPSE(2) PRIVATE(i, j, k, zbot, ztop, kbot, ktop, &
    !$OMP wgtlw, wbot, wtop, wsum, wmean, sum, helbot, heltop) SCHEDULE(runtime)
    DO j=2,ny-2
        DO i=2,nx-2
            zbot = zp(i,j,2) + uhmnhgt
            ztop = zp(i,j,2) + uhmxhgt
            !
            ! Find wbar, weighted-mean vertical velocity in column
            ! Find w at uhmnhgt AGL (bottom)
            !
            DO k=2,nz-3
                IF(zp(i,j,k) > zbot) EXIT
            END DO
            kbot = k
            wgtlw = (zp(i,j,kbot) - zbot)/(zp(i,j,kbot) - zp(i,j,kbot-1))
            wbot = (wgtlw*w(i,j,kbot-1)) + ((1. - wgtlw)*w(i,j,kbot))

            ! Find w at uhmxhgt AGL (top)
            DO k=2,nz-3
                IF(zp(i,j,k) > ztop) EXIT
            END DO
            ktop = k
            wgtlw = (zp(i,j,ktop) - ztop)/(zp(i,j,ktop) - zp(i,j,ktop-1))
            wtop = (wgtlw*w(i,j,ktop-1)) + ((1. - wgtlw)*w(i,j,ktop))

            ! First part, uhmnhgt to kbot
            wsum = 0.5*(w(i,j,kbot) + wbot)*(zp(i,j,kbot) - zbot)

            ! Integrate up through column
            DO k=(kbot+1),(ktop-1)
                wsum = wsum + 0.5*(w(i,j,k) + w(i,j,k-1))*(zp(i,j,k) - zp(i,j,k-1))
            END DO

            ! Last part, ktop-1 to uhmxhgt
            wsum = wsum + 0.5*(wtop + w(i,j,ktop-1))*(ztop - zp(i,j,ktop-1))
            wmean = wsum/(uhmxhgt - uhmnhgt)

            IF (wmean > 0.) THEN    ! column updraft, not downdraft

                ! Find helicity at uhmnhgt AGL (bottom)
                DO k=2,nz-3
                    IF (tem2(i,j,k) > zbot) EXIT
                END DO
                kbot = k
                wgtlw = (tem2(i,j,kbot) - zbot)/(tem2(i,j,kbot) - tem2(i,j,kbot-1))
                helbot = (wgtlw*tem1(i,j,kbot-1)) + ((1. - wgtlw)*tem1(i,j,kbot))

                ! Find helicity at uhmxhgt AGL (top)
                DO k=2,nz-3
                    IF (tem2(i,j,k) > ztop) EXIT
                END DO
                ktop = k
                wgtlw = (tem2(i,j,ktop) - ztop)/(tem2(i,j,ktop) - tem2(i,j,ktop-1))
                heltop = (wgtlw*tem1(i,j,ktop-1)) + ((1. - wgtlw)*tem1(i,j,ktop))

                ! First part, uhmnhgt to kbot
                sum = 0.5*(tem1(i,j,kbot) + helbot)*(tem2(i,j,kbot) - zbot)

                ! Integrate up through column
                DO k=(kbot+1),(ktop-1)
                    sum = sum + 0.5*(tem1(i,j,k) + tem1(i,j,k-1))*(tem2(i,j,k) - tem2(i,j,k-1))
                END DO

                ! Last part, ktop-1 to uhmxhgt
                uh(i,j) = sum + 0.5*(heltop + tem1(i,j,ktop-1))*(ztop - tem2(i,j,ktop-1))
            END IF
        END DO
    END DO
    !$OMP END DO

    !$OMP END PARALLEL

    RETURN

END SUBROUTINE DCALCUH

! The subroutines in this file were taken directly from RIP code written
! by Dr. Mark Stoelinga.  They were modified by Sherrie
! Fredrick(NCAR/MMM) to work with NCL February 2015.

!NCLFORTSTART
SUBROUTINE wrf_monotonic(out, in, lvprs, cor, idir, delta, ew, ns, nz, icorsw)

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: out

    INTEGER, INTENT(IN) :: idir, ew, ns, nz, icorsw
    REAL(KIND=8), INTENT(IN) :: delta
    REAL(KIND=8), DIMENSION(ew,ns,nz), INTENT(INOUT) :: in
    REAL(KIND=8), DIMENSION(ew,ns,nz), INTENT(OUT) :: out
    REAL(KIND=8), DIMENSION(ew,ns,nz), INTENT(IN) :: lvprs
    REAL(KIND=8), DIMENSION(ew,ns), INTENT(IN) :: cor


!NCLEND

    INTEGER :: i, j, k, k300

    !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(i, j, k, k300) SCHEDULE(runtime)
    DO j=1,ns
        DO i=1,ew
            k300 = -1

            IF (icorsw .EQ. 1 .AND. cor(i,j) .LT. 0.) THEN
                DO k=1,nz
                    in(i,j,k) = -in(i,j,k)
                END DO
            END IF

            ! First find k index that is at or below (height-wise)
            ! the 300 hPa level.
            DO k = 1,nz-1
                IF (lvprs(i,j,k) .LE. 300.D0) THEN
                    k300 = k
                    EXIT
                END IF
            END DO

            ! If the search fails for some reason, use the second to last
            ! k index
            IF (k300 .EQ. -1) THEN
                k300 = nz-1
            END IF

            DO k = k300,1,-1
                IF (idir .EQ. 1) THEN
                    out(i,j,k) = MIN(in(i,j,k), in(i,j,k+1) + delta)
                ELSE IF (idir .EQ. -1) THEN
                    out(i,j,k) = MAX(in(i,j,k), in(i,j,k+1) - delta)
                END IF
            END DO

            DO k = k300+1, nz
                IF (idir .EQ. 1) THEN
                    out(i,j,k) = MAX(in(i,j,k), in(i,j,k-1) - delta)
                ELSE IF (idir .EQ. -1) THEN
                    out(i,j,k) = MIN(in(i,j,k), in(i,j,k-1) + delta)
                END IF
            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE wrf_monotonic


!NCLFORTSTART
FUNCTION wrf_intrp_value(wvalp0, wvalp1, vlev, vcp0, vcp1, icase, errstat)
    USE wrf_constants, ONLY : ALGERR, SCLHT

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: icase
    REAL(KIND=8), INTENT(IN) :: wvalp0, wvalp1, vlev, vcp0, vcp1
    INTEGER, INTENT(INOUT) :: errstat
    REAL(KIND=8) :: wrf_intrp_value

!NCLEND

    REAL(KIND=8) :: valp0, valp1, rvalue
    REAL(KIND=8) :: chkdiff

    errstat = 0

    valp0 = wvalp0
    valp1 = wvalp1
    IF ( icase .EQ. 2) THEN  !GHT
        valp0=EXP(-wvalp0/SCLHT)
        valp1=EXP(-wvalp1/SCLHT)
    END IF

    chkdiff = vcp1 - vcp0
    IF(chkdiff .EQ. 0) THEN
        errstat = ALGERR
        !errmsg = "bad difference in vcp's"
        wrf_intrp_value = 0
        RETURN
        !PRINT *,"bad difference in vcp's"
        !STOP
    END IF

    rvalue = (vlev - vcp0)*(valp1 - valp0)/(vcp1 - vcp0) + valp0
    IF (icase .EQ. 2) THEN  !GHT
        wrf_intrp_value = -SCLHT*LOG(rvalue)
    ELSE
        wrf_intrp_value = rvalue
    END IF

    RETURN

END FUNCTION wrf_intrp_value

! NOTES:
! vcarray is the array holding the values for the vertical coordinate.
! It will always come in with the dimensions of the staggered U and V grid.

!NCLFORTSTART
SUBROUTINE wrf_vintrp(datain, dataout, pres, tk, qvp, ght, terrain,&
                      sfp, smsfp, vcarray, interp_levels, numlevels,&
                      icase, ew, ns, nz, extrap, vcor, logp, tempout, rmsg,&
                      errstat, errmsg)
    USE wrf_constants, ONLY : ALGERR, SCLHT, EXPON, EXPONI, GAMMA, GAMMAMD, TLCLC1, &
                          TLCLC2, TLCLC3, TLCLC4, THTECON1, THTECON2, THTECON3, &
                          CELKEL, EPS, USSALR

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: dataout

    INTEGER, INTENT(IN) :: ew, ns, nz, icase, extrap
    INTEGER, INTENT(IN) :: vcor, numlevels, logp
    REAL(KIND=8), DIMENSION(ew,ns,nz), INTENT(IN) :: datain, pres, tk, qvp
    REAL(KIND=8), DIMENSION(ew,ns,nz), INTENT(IN) :: ght
    REAL(KIND=8), DIMENSION(ew,ns), INTENT(IN) :: terrain, sfp, smsfp
    REAL(KIND=8), DIMENSION(ew,ns,numlevels), INTENT(OUT) :: dataout
    REAL(KIND=8), DIMENSION(ew,ns,nz), INTENT(IN) :: vcarray
    REAL(KIND=8), DIMENSION(numlevels), INTENT(IN) :: interp_levels

    REAL(KIND=8), DIMENSION(ew,ns), INTENT(INOUT) :: tempout

    REAL(KIND=8), INTENT(IN) :: rmsg
    INTEGER, INTENT(INOUT) :: errstat
    CHARACTER(LEN=*), INTENT(INOUT) :: errmsg

!NCLEND

    INTEGER :: nreqlvs, ripk !njx,niy
    INTEGER :: i, j, k, kupper !itriv
    INTEGER :: ifound, isign !miy,mjx
    INTEGER :: log_errcnt, interp_errcnt, interp_errstat
    REAL(KIND=8) :: rlevel, vlev, diff
    REAL(KIND=8) :: tmpvlev
    REAL(KIND=8) :: vcp1, vcp0, valp0, valp1
!    REAL(KIND=8) :: cvc
    REAL(KIND=8) :: vclhsl, vctophsl !qvlhsl,ttlhsl
    REAL(KIND=8) :: wrf_intrp_value
    REAL(KIND=8) :: plhsl, zlhsl, ezlhsl, tlhsl, psurf, pratio, tlev
    REAL(KIND=8) :: ezsurf, psurfsm, zsurf, qvapor, vt
    REAL(KIND=8) :: ezlev, plev, zlev, ptarget, dpmin, dp
    REAL(KIND=8) :: pbot, zbot, tbotextrap, e
    REAL(KIND=8) :: tlcl, gammam
    CHARACTER(LEN=1) :: cvcord

    ! Removes the warnings for uninitialized variables
    cvcord = ''
    plev = 0
    zlev = 0
    vlev = 0
    errstat = 0
    interp_errcnt = 0
    interp_errstat = 0
    log_errcnt = 0

    IF (vcor .EQ. 1) THEN
        cvcord = 'p'
    ELSE IF ((vcor .EQ. 2) .OR. (vcor .EQ. 3)) THEN
        cvcord = 'z'
    ELSE IF ((vcor .EQ. 4) .OR. (vcor .EQ. 5)) THEN
        cvcord = 't'
    END IF

    DO nreqlvs = 1,numlevels
        IF (cvcord .EQ. 'z') THEN
            ! Convert rlevel to meters from km
            rlevel = interp_levels(nreqlvs) * 1000.D0
            vlev = EXP(-rlevel/SCLHT)
        ELSE IF (cvcord .EQ. 'p') THEN
            vlev = interp_levels(nreqlvs)
        ELSE IF (cvcord .EQ. 't') THEN
            vlev = interp_levels(nreqlvs)
        END IF

        !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(i, j, k, ifound, &
        !$OMP ripk, vcp1, vcp0, valp0, valp1, tmpvlev, interp_errstat, &
        !$OMP vclhsl, vctophsl, diff, isign, plhsl, zlhsl, ezlhsl, tlhsl, &
        !$OMP zsurf, qvapor, psurf, psurfsm, ezsurf, plev, ezlev, zlev, &
        !$OMP ptarget, dpmin, kupper, pbot, zbot, pratio, tbotextrap, &
        !$OMP vt, tlev, gammam, e, tlcl) REDUCTION (+:log_errcnt, interp_errcnt) &
        !$OMP SCHEDULE(runtime)
        DO j=1,ns
            DO i=1,ew
                tempout(i,j) = rmsg
                ! Get the interpolated value that is within the model domain
                ifound = 0
                DO k = 1,nz-1
                    ripk = nz-k+1
                    vcp1 = vcarray(i,j,ripk-1)
                    vcp0 = vcarray(i,j,ripk)
                    valp0 = datain(i,j,ripk)
                    valp1 = datain(i,j,ripk-1)

                    IF ((vlev .GE. vcp0 .AND. vlev .LE. vcp1) .OR. &
                        (vlev .LE. vcp0 .AND. vlev .GE. vcp1)) THEN
                        ! print *,i,j,valp0,valp1
                        IF ((valp0 .EQ. rmsg) .OR. (valp1 .EQ. rmsg)) THEN
                            tempout(i,j) = rmsg
                            ifound = 1
                        ELSE
                            IF (logp .EQ. 1) THEN
                                vcp1 = LOG(vcp1)
                                vcp0 = LOG(vcp0)
                                IF (vlev .NE. 0.0D0) THEN
                                    tmpvlev = LOG(vlev)
                                ELSE
                                    log_errcnt = log_errcnt + 1
                                    tmpvlev = rmsg
                                END IF
                            ELSE
                                tmpvlev = vlev
                            END IF

                            IF (tmpvlev .NE. rmsg) THEN
                                tempout(i,j) = wrf_intrp_value(valp0, valp1, tmpvlev, vcp0, &
                                                               vcp1, icase, interp_errstat)

                                IF (interp_errstat .NE. 0) THEN
                                    tempout(i,j) = rmsg
                                    interp_errcnt = interp_errcnt + 1
                                END IF

                                ifound = 1
                            END IF
                        END IF

                        EXIT
                    END IF
                END DO !end for the k loop

                IF (ifound .EQ. 1) THEN !Grid point is in the model domain
                    CYCLE
                END IF

                !If the user has requested no extrapolatin then just assign
                !all values above or below the model level to rmsg.
                IF (extrap .EQ. 0) THEN
                    tempout(i,j) = rmsg
                    CYCLE
                END IF

                ! The grid point is either above or below the model domain
                ! First we will check to see if the grid point is above the
                ! model domain.
                vclhsl = vcarray(i,j,1)  !lowest model level
                vctophsl = vcarray(i,j,nz) !highest model level
                diff = vctophsl - vclhsl
                isign = NINT(diff/ABS(diff))

                IF (isign*vlev .GE. isign*vctophsl) THEN
                    ! Assign the highest model level to the out array
                    tempout(i,j) = datain(i,j,nz)
                    CYCLE
                END IF

                ! Only remaining possibility is that the specified level is below
                ! lowest model level.  If lowest model level value is missing,
                ! set interpolated value to missing.

                IF (datain(i,j,1) .EQ. rmsg) THEN
                    tempout(i,j) = rmsg
                    CYCLE
                END IF

                ! If the field comming in is not a pressure,temperature or height
                ! field we can set the output array to the value at the lowest
                ! model level.

                tempout(i,j) = datain(i,j,1)

                ! For the special cases of pressure on height levels or height on
                ! pressure levels, or temperature-related variables on pressure or
                ! height levels, perform a special extrapolation based on
                ! US Standard Atmosphere.  Here we calcualate the surface pressure
                ! with the altimeter equation.  This is how RIP calculates the
                ! surface pressure.
                IF (icase .GT. 0) THEN
                    plhsl = pres(i,j,1) * 0.01D0  !pressure at lowest model level
                    zlhsl = ght(i,j,1)            !grid point height a lowest model level
                    ezlhsl = EXP(-zlhsl/SCLHT)
                    tlhsl = tk(i,j,1)             !temperature in K at lowest model level
                    zsurf = terrain(i,j)
                    qvapor = MAX((qvp(i,j,1)*.001D0),1.e-15)
                    ! virtual temperature
                    ! vt     = tlhsl * (eps + qvapor)/(eps*(1.0 + qvapor))
                    ! psurf  = plhsl * (vt/(vt+USSALR * (zlhsl-zsurf)))**rconst
                    psurf = sfp(i,j)
                    psurfsm = smsfp(i,j)
                    ezsurf = EXP(-zsurf/SCLHT)

                    ! The if for checking above ground
                    IF ((cvcord .EQ. 'z' .AND. vlev .LT. ezsurf) .OR. &
                        (cvcord .EQ. 'p' .AND. vlev .LT. psurf)) THEN

                    ! We are below the lowest data level but above the ground.
                    ! Use linear interpolation (linear in prs and exp-height).

                        IF (cvcord .EQ. 'p') THEN
                            plev = vlev
                            ezlev = ((plev - plhsl)*&
                                    ezsurf + (psurf - plev)*ezlhsl)/(psurf - plhsl)
                            zlev = -SCLHT*LOG(ezlev)
                            IF (icase .EQ. 2) THEN
                                tempout(i,j) = zlev
                                CYCLE
                            END IF

                        ELSE IF (cvcord .EQ. 'z') THEN
                            ezlev = vlev
                            zlev = -SCLHT*LOG(ezlev)
                            plev = ((ezlev - ezlhsl)*&
                                   psurf + (ezsurf - ezlev)*plhsl)/(ezsurf - ezlhsl)
                            IF (icase .EQ. 1) THEN
                                tempout(i,j) = plev * 100.
                                CYCLE
                            END IF
                        END IF

                    ELSE   !else for checking above ground
                        ptarget = psurfsm - 150.D0
                        dpmin = 1.E4
                        DO k=1,nz
                            ripk = nz-k+1
                            dp = ABS((pres(i,j,ripk) * 0.01D0) - ptarget)
                            IF (dp .GT. dpmin) THEN
                                EXIT
                            END IF
                            dpmin = MIN(dpmin, dp)
                        END DO

                        kupper = k-1

                        ripk = nz - kupper + 1
                        pbot = MAX(plhsl,psurf)
                        zbot = MIN(zlhsl,zsurf)
                        pratio = pbot/(pres(i,j,ripk) * 0.01D0)
                        tbotextrap = tk(i,j,ripk)*(pratio)**EXPON
                        ! virtual temperature
                        vt = tbotextrap * (EPS + qvapor)/(EPS*(1.0D0 + qvapor))
                        IF (cvcord .EQ. 'p') THEN
                            plev = vlev
                            zlev = zbot + vt/USSALR*(1. - (vlev/pbot)**EXPON)
                            IF (icase .EQ. 2) THEN
                                tempout(i,j) = zlev
                                CYCLE
                            END IF
                        ELSE IF (cvcord .EQ. 'z') THEN
                            zlev = -sclht*LOG(vlev)
                            plev = pbot*(1. + USSALR/vt*(zbot - zlev))**EXPONI
                            IF (icase .EQ. 1) THEN
                                tempout(i,j) = plev * 100.
                                CYCLE
                            END IF
                        END IF
                    END IF !end if for checking above ground
                END IF !for icase gt 0

                IF (icase .GT. 2) THEN !extrapolation for temperature
                    tlev = tlhsl + (zlhsl - zlev)*USSALR
                    qvapor = MAX(qvp(i,j,1), 1.e-15)
                    gammam = GAMMA*(1. + GAMMAMD*qvapor)
                    IF (icase .EQ. 3) THEN
                        tempout(i,j) = tlev - CELKEL
                    ELSE IF (icase .EQ. 4) THEN
                        tempout(i,j) = tlev
                    ! Potential temperature - theta
                    ELSE IF (icase .EQ. 5) THEN
                        tempout(i,j) = tlev*(1000.D0/plev)**gammam
                    ! extrapolation for equivalent potential temperature
                    ELSE IF (icase .EQ. 6) THEN
                        e = qvapor*plev/(EPS + qvapor)
                        tlcl = TLCLC1/(LOG(tlev**TLCLC2/e) - TLCLC3) + TLCLC4
                        tempout(i,j)=tlev*(1000.D0/plev)**(gammam)*&
                                     EXP((THTECON1/tlcl - THTECON2)*&
                                     qvapor*(1. + THTECON3*qvapor))
                    END IF
                END IF

 !333  CONTINUE

            END DO
        END DO
        !$OMP END PARALLEL DO

        IF (log_errcnt > 0) THEN
            errstat = ALGERR
            WRITE(errmsg, *) "Pres=0.  Unable to take log of 0."
            RETURN
        END IF

        IF (interp_errcnt > 0) THEN
            errstat = ALGERR
            WRITE(errmsg, *) "bad difference in vcp's"
            RETURN
        END IF

        !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(runtime)
        DO j = 1,ns
            DO i = 1,ew
                dataout(i,j,nreqlvs) = tempout(i,j)
            END DO
        END DO
        !$OMP END PARALLEL DO

    END DO !end for the nreqlvs

    RETURN

END SUBROUTINE wrf_vintrp

PROGRAM sizes

    USE omp_lib

    PRINT *, "SIZES"
    PRINT *, INT(OMP_SCHED_KIND, kind=OMP_SCHED_KIND)
    PRINT *, INT(OMP_LOCK_KIND, kind=OMP_LOCK_KIND)
    PRINT *, INT(OMP_NEST_LOCK_KIND, kind=OMP_NEST_LOCK_KIND)
    PRINT *, INT(omp_sched_static, kind=OMP_SCHED_KIND)
    PRINT *, INT(omp_sched_dynamic, kind=OMP_SCHED_KIND)
    PRINT *, INT(omp_sched_guided, kind=OMP_SCHED_KIND)
    PRINT *, INT(omp_sched_auto, kind=OMP_SCHED_KIND)

END PROGRAM sizes

!   ***************************************************************
!   * Storm Relative Helicity (SRH) is a measure of the           *
!   * streamwise vorticity within the inflow environment of a     *
!   * convective storm. It is calculated by multiplying the       *
!   * storm-relative inflow velocity vector (Vh-C) by the         *
!   * streamwise vorticity (Zh) and integrating this quantity     *
!   * over the inflow depth (lowest 1-3 km layers above ground    *
!   * level). It describes the extent to which corkscrew-like     *
!   * motion occurs (similar to the spiraling motion of an        *
!   * American football). SRH corresponds to the transfer of      *
!   * vorticity from the environment to an air parcel in          *
!   * convective motion and is used to predict the potential      *
!   * for tornadic development (cyclonic updraft rotation) in     *
!   * right-moving supercells.                                    *
!   *                                                             *
!   * There is no clear threshold value for SRH when forecasting  *
!   * supercells, since the formation of supercells appears to be *
!   * related more strongly to the deeper layer vertical shear.   *
!   * Larger values of 0-3-km SRH (greater than 250 m**2/s**2)    *
!   * and 0-1-km SRH (greater than 100 m**2/s**2), suggest an     *
!   * increased threat of tornadoes with supercells. For SRH,     *
!   * larger values are generally better, but there are no clear  *
!   * "boundaries" between non-tornadic and significant tornadic  *
!   * supercells.                                                 *
!   *                                                             *
!   * SRH < 100 (lowest 1 km): cutoff value                       *
!   * SRH = 150-299: supercells possible with weak tornadoes      *
!   * SRH = 300-499: very favorable to supercell development and  *
!   *                strong tornadoes                             *
!   * SRH > 450    : violent tornadoes                            *
!   ***************************************************************

! NCLFORTSTART
SUBROUTINE DCALRELHL(u, v, ght, ter, lat, top, sreh, miy, mjx, mkzh)
    USE wrf_constants, ONLY : PI, RAD_PER_DEG, DEG_PER_RAD

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: sreh

    INTEGER, INTENT(IN) :: miy, mjx, mkzh
    REAL(KIND=8), DIMENSION(miy,mjx,mkzh), INTENT(IN) :: u, v, ght
    REAL(KIND=8), INTENT(IN) :: top
    REAL(KIND=8), DIMENSION(miy,mjx), INTENT(IN) :: ter
    REAL(KIND=8), DIMENSION(miy,mjx), INTENT(IN) :: lat
    REAL(KIND=8), DIMENSION(miy,mjx), INTENT(OUT) :: sreh

! NCLEND

    ! This helicity code was provided by Dr. Craig Mattocks, and
    ! verified by Cindy Bruyere to produce results equivalent to
    ! those generated by RIP4. (The code came from RIP4?)

    REAL(KIND=8) :: dh, sdh, su, sv, ua, va, asp, adr, bsp, bdr
    REAL(KIND=8) :: cu, cv, x, sum
    INTEGER :: i, j, k, k10, k3, ktop
    !REAL(KIND=8), PARAMETER :: DTR=PI/180.d0, DPR=180.d0/PI

    !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(i,j,k,k10,k3,ktop, cu, cv, x, &
    !$OMP sum, dh, sdh, su, sv, ua, va, asp, adr, bsp, bdr) SCHEDULE(runtime)
    DO j=1, mjx
        DO i=1, miy
            sdh = 0.D0
            su = 0.D0
            sv = 0.D0
            k3 = 0
            k10 = 0
            ktop = 0
            DO k = mkzh, 2, -1
                IF (((ght(i,j,k) - ter(i,j)) .GT. 10000.D0) .AND. (k10 .EQ. 0)) THEN
                    k10 = k
                    EXIT
                ENDIF
                IF (((ght(i,j,k) - ter(i,j)) .GT. top) .AND. (ktop .EQ. 0)) THEN
                    ktop = k
                ENDIF
                IF (((ght(i,j,k) - ter(i,j)) .GT. 3000.D0) .AND. (k3 .EQ. 0)) THEN
                    k3 = k
                ENDIF
            END DO

            IF (k10 .EQ. 0) THEN
                k10 = 2
            ENDIF

            DO k = k3, k10, -1
                dh = ght(i,j,k-1) - ght(i,j,k)
                sdh = sdh + dh
                su = su + 0.5D0*dh*(u(i,j,k-1) + u(i,j,k))
                sv = sv + 0.5D0*dh*(v(i,j,k-1) + v(i,j,k))
            END DO

            ua = su/sdh
            va = sv/sdh
            asp = SQRT(ua*ua + va*va)
            IF (ua .EQ. 0.D0 .AND. va .EQ. 0.D0) THEN
                adr = 0.D0
            ELSE
                adr = DEG_PER_RAD * (PI + ATAN2(ua,va))
            ENDIF

            bsp = 0.75D0*asp

            IF (lat(i,j) .GE. 0) THEN ! Northern hemisphern
                bdr = adr + 30.D0
            ELSE ! Southern hemisphere
                bdr = adr - 30.D0
            END IF

            IF (bdr .GT. 360.D0) THEN
                bdr = bdr - 360.D0
            ENDIF

            cu = -bsp*SIN(bdr * RAD_PER_DEG)
            cv = -bsp*COS(bdr * RAD_PER_DEG)
            sum = 0.D0
            DO k = mkzh-1, ktop, -1
                x = ((u(i,j,k) - cu)*(v(i,j,k) - v(i,j,k+1))) - &
                    ((v(i,j,k) - cv)*(u(i,j,k) - u(i,j,k+1)))
                sum = sum + x
            END DO
            sreh(i,j) = -sum
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DCALRELHL

MODULE omp_constants
    INTEGER, PARAMETER :: fomp_sched_kind = 4
    INTEGER, PARAMETER :: fomp_lock_kind = 4
    INTEGER, PARAMETER :: fomp_nest_lock_kind = 8
    INTEGER(KIND=fomp_sched_kind), PARAMETER :: fomp_sched_static = 1
    INTEGER(KIND=fomp_sched_kind), PARAMETER :: fomp_sched_dynamic = 2
    INTEGER(KIND=fomp_sched_kind), PARAMETER :: fomp_sched_guided = 3
    INTEGER(KIND=fomp_sched_kind), PARAMETER :: fomp_sched_auto = 4
END MODULE omp_constants


FUNCTION fomp_enabled()

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_enabled

    fomp_enabled = .FALSE.

END FUNCTION fomp_enabled


SUBROUTINE fomp_set_num_threads(num_threads)

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: num_threads
    IF (.FALSE.) PRINT *, num_threads

END SUBROUTINE fomp_set_num_threads


FUNCTION fomp_get_num_threads()

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_num_threads

    fomp_get_num_threads = -1

END FUNCTION fomp_get_num_threads


FUNCTION fomp_get_max_threads()

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_max_threads

    fomp_get_max_threads = -1

END FUNCTION fomp_get_max_threads


FUNCTION fomp_get_thread_num()

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_thread_num

    fomp_get_thread_num = -1

END FUNCTION fomp_get_thread_num


FUNCTION fomp_get_num_procs()

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_num_procs

    fomp_get_num_procs = -1

END FUNCTION fomp_get_num_procs


FUNCTION fomp_in_parallel()

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_in_parallel

    fomp_in_parallel = .FALSE.

END FUNCTION fomp_in_parallel


SUBROUTINE fomp_set_dynamic(dynamic_threads)

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL, INTENT(IN) :: dynamic_threads
    IF (.FALSE.) PRINT *, dynamic_threads

END SUBROUTINE fomp_set_dynamic


FUNCTION fomp_get_dynamic()

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_get_dynamic

    fomp_get_dynamic = .FALSE.

END FUNCTION fomp_get_dynamic


SUBROUTINE fomp_set_nested(nested)

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL, INTENT(IN) :: nested
    IF (.FALSE.) PRINT *, nested

END SUBROUTINE fomp_set_nested


FUNCTION fomp_get_nested()

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_get_nested

    fomp_get_nested = .FALSE.

END FUNCTION fomp_get_nested


SUBROUTINE fomp_set_schedule(kind, modifier)

    USE omp_constants, ONLY : fomp_sched_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_sched_kind), INTENT(IN) :: kind
    INTEGER, INTENT(IN) :: modifier
    IF (.FALSE.) PRINT *, kind, modifier

END SUBROUTINE fomp_set_schedule


SUBROUTINE fomp_get_schedule(kind, modifier)

    USE omp_constants, ONLY : fomp_sched_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_sched_kind), INTENT(OUT) :: kind
    INTEGER, INTENT(OUT) :: modifier

    kind = -1
    modifier = -1

END SUBROUTINE fomp_get_schedule


FUNCTION fomp_get_thread_limit()

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_thread_limit

    fomp_get_thread_limit = -1

END FUNCTION fomp_get_thread_limit


SUBROUTINE fomp_set_max_active_levels(max_levels)

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: max_levels
    IF (.FALSE.) PRINT *, max_levels

END SUBROUTINE fomp_set_max_active_levels


FUNCTION fomp_get_max_active_levels()

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_max_active_levels

    fomp_get_max_active_levels = -1

END FUNCTION fomp_get_max_active_levels


FUNCTION fomp_get_level()

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_level

    fomp_get_level = -1

END FUNCTION fomp_get_level


FUNCTION fomp_get_ancestor_thread_num(level)

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: level
    INTEGER :: fomp_get_ancestor_thread_num
    IF (.FALSE.) PRINT *, level

    fomp_get_ancestor_thread_num = -1

END FUNCTION fomp_get_ancestor_thread_num


FUNCTION fomp_get_team_size(level)

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: level
    INTEGER :: fomp_get_team_size
    IF (.FALSE.) PRINT *, level

    fomp_get_team_size = -1

END FUNCTION fomp_get_team_size


FUNCTION fomp_get_active_level()

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_active_level

    fomp_get_active_level = -1

END FUNCTION fomp_get_active_level


FUNCTION fomp_in_final()

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_in_final

    fomp_in_final = .FALSE.

END FUNCTION fomp_in_final


SUBROUTINE fomp_init_lock(svar)

    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(OUT) :: svar

    svar = -1

END SUBROUTINE fomp_init_lock


SUBROUTINE fomp_init_nest_lock(nvar)

    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(OUT) :: nvar

    nvar = -1

END SUBROUTINE fomp_init_nest_lock


SUBROUTINE fomp_destroy_lock(svar)

    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar
    IF (.FALSE.) PRINT *, svar

END SUBROUTINE fomp_destroy_lock


SUBROUTINE fomp_destroy_nest_lock(nvar)

    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar
    IF (.FALSE.) PRINT *, nvar

END SUBROUTINE fomp_destroy_nest_lock


SUBROUTINE fomp_set_lock(svar)

    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar
    IF (.FALSE.) PRINT *, svar

END SUBROUTINE fomp_set_lock


SUBROUTINE fomp_set_nest_lock(nvar)

    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar
    IF (.FALSE.) PRINT *, nvar

END SUBROUTINE fomp_set_nest_lock


SUBROUTINE fomp_unset_lock(svar)

    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar
    IF (.FALSE.) PRINT *, svar

END SUBROUTINE fomp_unset_lock


SUBROUTINE fomp_unset_nest_lock(nvar)

    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar
    IF (.FALSE.) PRINT *, nvar

END SUBROUTINE fomp_unset_nest_lock


FUNCTION fomp_test_lock(svar)

    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar
    LOGICAL :: fomp_test_lock
    IF (.FALSE.) PRINT *, svar

    fomp_test_lock = .FALSE.

END FUNCTION fomp_test_lock


FUNCTION fomp_test_nest_lock(nvar)

    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar
    INTEGER :: fomp_test_nest_lock
    IF (.FALSE.) PRINT *, nvar

    fomp_test_nest_lock = -1

END FUNCTION fomp_test_nest_lock


FUNCTION fomp_get_wtime()

    IMPLICIT NONE

    !f2py threadsafe

    REAL (KIND=8) :: fomp_get_wtime

    fomp_get_wtime = -1

END FUNCTION fomp_get_wtime


FUNCTION fomp_get_wtick()

    IMPLICIT NONE

    !f2py threadsafe

    REAL (KIND=8) :: fomp_get_wtick

    fomp_get_wtick = -1

END FUNCTION fomp_get_wtick

! Theta-e
!NCLFORTSTART
SUBROUTINE DEQTHECALC(qvp, tmk, prs, eth, miy, mjx, mkzh)
    USE wrf_constants, ONLY : EPS, GAMMA, GAMMAMD, TLCLC1, TLCLC2, TLCLC3, TLCLC4, &
                          THTECON1, THTECON2, THTECON3

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: eth

    ! Input variables
    ! Sizes
    INTEGER,INTENT(IN) :: miy, mjx, mkzh
    ! Qvapor [g/kg]
    REAL(KIND=8), DIMENSION(miy,mjx,mkzh), INTENT(IN) :: qvp
    ! Temperature [K]
    REAL(KIND=8), DIMENSION(miy,mjx,mkzh), INTENT(IN) :: tmk
    ! full pressure (=P+PB) [hPa]
    REAL(KIND=8), DIMENSION(miy,mjx,mkzh), INTENT(IN) :: prs
    ! Output variable
    ! equivalent potential temperature [K]
    REAL(KIND=8), DIMENSION(miy,mjx,mkzh), INTENT(OUT) :: eth

!NCLEND

    ! local variables
    REAL(KIND=8) :: q
    REAL(KIND=8) :: t
    REAL(KIND=8) :: p
    REAL(KIND=8) :: e
    REAL(KIND=8) :: tlcl
    INTEGER :: i, j, k

    !$OMP PARALLEL DO COLLAPSE(3) PRIVATE(i, j, k, q, t, p, e, tlcl) &
    !$OMP SCHEDULE(runtime)
    DO k = 1,mkzh
        DO j = 1,mjx
            DO i = 1,miy
                q = MAX(qvp(i,j,k), 1.D-15)
                t = tmk(i,j,k)
                p = prs(i,j,k)/100.
                e = q*p/(EPS + q)
                tlcl = TLCLC1/(LOG(t**TLCLC2/e) - TLCLC3) + TLCLC4
                eth(i,j,k) = tmk(i,j,k)*(1000.D0/p)**(GAMMA*(1.D0 + GAMMAMD*q))* &
                        EXP((THTECON1/tlcl - THTECON2)*q*(1.D0 + THTECON3*q))
            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DEQTHECALC

!NCLFORTSTART
SUBROUTINE wrfcttcalc(prs, tk, qci, qcw, qvp, ght, ter, ctt, pf, haveqci,&
             fill_nocloud, missing, opt_thresh, nz, ns, ew)
    USE wrf_constants, ONLY : EPS, USSALR, RD, G, ABSCOEFI, ABSCOEF, CELKEL

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: ctt

    INTEGER, INTENT(IN) :: nz, ns, ew, haveqci, fill_nocloud
    REAL(KIND=8), DIMENSION(ew,ns,nz), INTENT(IN) :: ght, prs, tk, qci, qcw, qvp
    REAL(KIND=8), DIMENSION(ew,ns), INTENT(IN) :: ter
    REAL(KIND=8), DIMENSION(ew,ns), INTENT(OUT) :: ctt
    REAL(KIND=8), INTENT(IN) :: missing
    REAL(KIND=8), INTENT(IN) :: opt_thresh
    REAL(KIND=8), DIMENSION(ew,ns,nz), INTENT(INOUT) :: pf


!NCLEND

    !     REAL(KIND=8) ::     znfac(nz)

    ! LOCAL VARIABLES
    INTEGER i,j,k,ripk
    REAL(KIND=8) :: opdepthu, opdepthd, dp, arg1, fac, prsctt, ratmix
    REAL(KIND=8) :: arg2, agl_hgt, vt

    REAL(KIND=8) :: p1, p2

    !$OMP PARALLEL

    ! Calculate the surface pressure
    !$OMP DO COLLAPSE(2) PRIVATE(i, j, ratmix, arg1, arg2, vt, agl_hgt) &
    !$OMP SCHEDULE(runtime)
    DO j=1,ns
        DO i=1,ew
           ratmix = .001D0*qvp(i,j,1)
           arg1 = EPS + ratmix
           arg2 = EPS*(1. + ratmix)
           vt = tk(i,j,1)*arg1/arg2 !Virtual temperature
           agl_hgt = ght(i,j,nz) - ter(i,j)
           arg1 = -G/(RD*USSALR)
           pf(i,j,nz) = prs(i,j,1)*(vt/(vt + USSALR*(agl_hgt)))**(arg1)
        END DO
    END DO
    !$OMP END DO

    !$OMP DO COLLAPSE(3) PRIVATE(i, j, k, ripk) SCHEDULE(runtime)
    DO k=1,nz-1
        DO j=1,ns
            DO i=1,ew
                ripk = nz-k+1
                pf(i,j,k) = .5D0*(prs(i,j,ripk) + prs(i,j,ripk-1))
            END DO
        END DO
    END DO
    !$OMP END DO

    !$OMP DO COLLAPSE(2) PRIVATE(i, j, k, ripk, opdepthd, opdepthu, &
    !$OMP prsctt, dp, p1, p2, fac, arg1) SCHEDULE(runtime)
    DO j=1,ns
        DO i=1,ew
            opdepthd = 0.D0
            k = 0
            prsctt = -1

            ! Integrate downward from model top, calculating path at full
            ! model vertical levels.

            DO k=2,nz
                opdepthu = opdepthd
                ripk = nz - k + 1

                IF (k .NE. 1) THEN
                    dp = 100.D0*(pf(i,j,k) - pf(i,j,k-1))  ! should be in Pa
                ELSE
                    dp = 200.D0*(pf(i,j,1) - prs(i,j,nz))  ! should be in Pa
                END IF

                IF (haveqci .EQ. 0) then
                    IF (tk(i,j,ripk) .LT. CELKEL) then
                        ! Note: abscoefi is m**2/g, qcw is g/kg, so no convrsion needed
                        opdepthd = opdepthu + ABSCOEFI*qcw(i,j,ripk) * dp/G
                    ELSE
                        opdepthd = opdepthu + ABSCOEF*qcw(i,j,ripk) * dp/G
                    END IF
                ELSE
                    opdepthd = opdepthd + (ABSCOEF*qcw(i,j,ripk) + ABSCOEFI*qci(i,j,ripk))*dp/G
                END IF

                IF (opdepthd .LT. opt_thresh .AND. k .LT. nz) THEN
                    CYCLE

                ELSE IF (opdepthd .LT. opt_thresh .AND. k .EQ. nz) THEN
                    IF (fill_nocloud .EQ. 0) THEN
                        prsctt = prs(i,j,1)
                    ENDIF
                    EXIT
                ELSE
                    fac = (1. - opdepthu)/(opdepthd - opdepthu)
                    prsctt = pf(i,j,k-1) + fac*(pf(i,j,k) - pf(i,j,k-1))
                    prsctt = MIN(prs(i,j,1), MAX(prs(i,j,nz), prsctt))
                    EXIT
                END IF
            END DO

            ! prsctt should only be 0 if fill values are used
            IF (prsctt .GT. -1) THEN
                DO k=2,nz
                    ripk = nz - k + 1
                    p1 = prs(i,j,ripk+1)
                    p2 = prs(i,j,ripk)
                    IF (prsctt .GE. p1 .AND. prsctt .LE. p2) THEN
                        fac = (prsctt - p1)/(p2 - p1)
                        arg1 = fac*(tk(i,j,ripk) - tk(i,j,ripk+1)) - CELKEL
                        ctt(i,j) = tk(i,j,ripk+1) + arg1
                        EXIT
                    END IF
                END DO
            ELSE
                ctt(i,j) = missing
            END IF
        END DO
    END DO
    !$OMP END DO

    !$OMP END PARALLEL
    RETURN

END SUBROUTINE wrfcttcalc

!NCLFORTSTART
SUBROUTINE DCOMPUTEPW(p, tv, qv, ht, pw, nx, ny, nz, nzh)
    USE wrf_constants, ONLY : RD

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: pw

    INTEGER, INTENT(IN) :: nx, ny, nz, nzh
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: p, tv, qv
    REAL(KIND=8), DIMENSION(nx,ny,nzh), INTENT(IN) :: ht
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(OUT) :: pw

!NCLEND

    INTEGER :: i, j, k
    !REAL(KIND=8),PARAMETER :: R=287.06

    pw = 0

    !$OMP PARALLEL

    DO k=1,nz
        !$OMP DO COLLAPSE(2) SCHEDULE(runtime)
        DO j=1,ny
            DO i=1,nx
                pw(i,j) = pw(i,j) + ((p(i,j,k)/(RD*tv(i,j,k)))*qv(i,j,k)*(ht(i,j,k+1) - ht(i,j,k)))
            END DO
        END DO
        !$OMP END DO
    END DO

    !$OMP END PARALLEL

    RETURN

END SUBROUTINE DCOMPUTEPW

!======================================================================
!
! !IROUTINE: VIRTUAL -- Calculate virtual temperature (K)
!
! !DESCRIPTION:
!
!   This function returns a single value of virtual temperature in
!   K, given temperature in K and mixing ratio in kg/kg.  For an
!   array of virtual temperatures, use subroutine VIRTUAL_TEMP.
!
! !INPUT:
!    RATMIX - water vapor mixing ratio (kg/kg)
!    TEMP   - temperature (K)
!
! !OUTPUT:
!    TV     - Virtual temperature (K)
!

! NCLFORTSTART
REAL(KIND=8) FUNCTION TVIRTUAL(temp, ratmix)
    USE wrf_constants, ONLY : EPS

    !f2py threadsafe

    IMPLICIT NONE
    REAL(KIND=8), INTENT(IN) :: temp, ratmix

! NCLEND

    TVIRTUAL = temp*(EPS + ratmix)/(EPS*(1.D0 + ratmix))

    RETURN

END FUNCTION TVIRTUAL

! NCLFORTSTART
REAL(KIND=8) FUNCTION TONPSADIABAT(thte, prs, psadithte, psadiprs, psaditmk, gamma,&
                                   errstat, errmsg)
    USE wrf_constants, ONLY : ALGERR
!!$OMP DECLARE SIMD (TONPSADIABAT)
!!uniform(thte,prs,psadithte,psadiprs,psaditmk)
    !f2py threadsafe

    IMPLICIT NONE
    REAL(KIND=8), INTENT(IN) :: thte
    REAL(KIND=8), INTENT(IN) :: prs
    REAL(KIND=8), DIMENSION(150), INTENT(IN) :: psadithte
    REAL(KIND=8), DIMENSION(150), INTENT(IN) :: psadiprs
    REAL(KIND=8), DIMENSION(150,150), INTENT(IN) :: psaditmk
    REAL(KIND=8), INTENT(IN) :: gamma
    INTEGER, INTENT(INOUT) :: errstat
    CHARACTER(LEN=*), INTENT(INOUT) :: errmsg

! NCLEND

    REAL(KIND=8) :: fracjt
    REAL(KIND=8) :: fracjt2
    REAL(KIND=8) :: fracip
    REAL(KIND=8) :: fracip2
    
    INTEGER :: l1, h1, mid1, rang1, l2, h2, mid2, rang2
    INTEGER :: ip, jt

    !   This function gives the temperature (in K) on a moist adiabat
    !   (specified by thte in K) given pressure in hPa.  It uses a
    !   lookup table, with data that was generated by the Bolton (1980)
    !   formula for theta_e.

    !     First check if pressure is less than min pressure in lookup table.
    !     If it is, assume parcel is so dry that the given theta-e value can
    !     be interpretted as theta, and get temperature from the simple dry
    !     theta formula.

    IF (prs .LE. psadiprs(150)) THEN
        TONPSADIABAT = thte * (prs/1000.D0)**gamma
        RETURN
    END IF

    !   Otherwise, look for the given thte/prs point in the lookup table.

    jt = -1
    l1 = 1
    h1 = 149
    rang1 = h1 - l1
    mid1 = (h1 + l1) / 2
    DO WHILE(rang1 .GT. 1)
        IF (thte .GE. psadithte(mid1)) THEN
           l1 = mid1 
        ELSE
           h1 = mid1 
        END IF
        rang1 = h1 - l1
        mid1 = (h1 + l1) / 2
    END DO
    jt = l1

   ! DO jtch = 1, 150-1
   !     IF (thte .GE. psadithte(jtch) .AND. thte .LT. psadithte(jtch+1)) THEN
   !         jt = jtch
   !         EXIT
  !          !GO TO 213
  !      END IF
  !  END DO

    ip = -1
    l2 = 1
    h2 = 149
    rang2 = h2 - l2
    mid2 = (h2 + l2) / 2
    DO WHILE(rang2 .GT. 1)
        IF (prs .LE. psadiprs(mid2)) THEN
           l2 = mid2 
        ELSE
           h2 = mid2 
        END IF
        rang2 = h2 - l2
        mid2 = (h2 + l2) / 2
    END DO
    ip = l2

   ! ip = -1
   ! DO ipch = 1, 150-1
   !     IF (prs .LE. psadiprs(ipch) .AND. prs .GT. psadiprs(ipch+1)) THEN
   !         ip = ipch
   !         EXIT
   !         !GO TO 215
   !     END IF
   ! END DO

    IF (jt .EQ. -1 .OR. ip .EQ. -1) THEN
        ! Set the error and return
        TONPSADIABAT = -1
        errstat = ALGERR
        WRITE(errmsg, *) "capecalc3d: Outside of lookup table bounds. prs,thte=", prs, thte
        RETURN
    END IF

    fracjt = (thte-psadithte(jt)) / (psadithte(jt+1)-psadithte(jt))
    fracjt2 = 1.D0 - fracjt
    fracip = (psadiprs(ip)-prs) / (psadiprs(ip)-psadiprs(ip+1))
    fracip2 = 1.D0 - fracip

    IF (psaditmk(ip,jt) .GT. 1D9 .OR. psaditmk(ip+1,jt) .GT. 1D9 .OR. &
        psaditmk(ip,jt+1) .GT. 1D9 .OR. psaditmk(ip+1,jt+1) .GT. 1D9) THEN
        ! Set the error and return
        TONPSADIABAT = -1
        errstat = ALGERR
        WRITE(errmsg, *) "capecalc3d: Tried to access missing temperature in lookup table. ", &
                 "Prs and Thte probably unreasonable. prs,thte=", prs, thte
        RETURN
    END IF

    TONPSADIABAT = fracip2*fracjt2*psaditmk(ip,jt) + fracip*fracjt2*psaditmk(ip+1,jt) + &
            fracip2*fracjt*psaditmk(ip,jt+1) + fracip*fracjt*psaditmk(ip+1,jt+1)

    RETURN

END FUNCTION TONPSADIABAT

!NCLFORTSTART
SUBROUTINE DLOOKUP_TABLE(psadithte, psadiprs, psaditmk, fname, errstat, errmsg)
    USE wrf_constants, ONLY : ALGERR

    !f2py threadsafe

    REAL(KIND=8), DIMENSION(150), INTENT(INOUT) :: psadithte, psadiprs
    REAL(KIND=8), DIMENSION(150,150), INTENT(INOUT) :: psaditmk
    CHARACTER(LEN=*), INTENT(IN) :: fname
    INTEGER, INTENT(INOUT) :: errstat
    CHARACTER(LEN=*), INTENT(INOUT) :: errmsg

!NCLEND

    ! Locals
    INTEGER :: iustnlist, i, nthte, nprs, ip, jt

    !      FNAME = 'psadilookup.dat'
    iustnlist = 33
    OPEN (UNIT=iustnlist, FILE=fname, FORM='formatted', STATUS='old', ACTION='read')

    DO i = 1,14
        READ (iustnlist, FMT=*)
    END DO

    READ (iustnlist, FMT=*) nthte, nprs

    IF (nthte .NE. 150 .OR. nprs .NE. 150) THEN
        errstat = ALGERR
        errmsg = "Number of pressure or theta_e levels in lookup table file not 150"
        RETURN
    END IF

    READ (iustnlist, FMT="(5D15.7)") (psadithte(jt),jt=1,nthte)
    READ (iustnlist, FMT="(5D15.7)") (psadiprs(ip),ip=1,nprs)
    READ (iustnlist, FMT="(5D15.7)") ((psaditmk(ip,jt),ip=1,nprs),jt=1,nthte)

    CLOSE (iustnlist)

    RETURN

END SUBROUTINE DLOOKUP_TABLE


!     Historically, this routine calculated the pressure at full sigma
!     levels when RIP was specifically designed for MM4/MM5 output.
!     With the new generalized RIP (Feb '02), this routine is still
!     intended to calculate a set of pressure levels that bound the
!     layers represented by the vertical grid points, although no such
!     layer boundaries are assumed to be defined.  The routine simply
!     uses the midpoint between the pressures of the vertical grid
!     points as the bounding levels.  The array only contains mkzh
!     levels, so the pressure of the top of the uppermost layer is
!     actually excluded.  The kth value of pf is the lower bounding
!     pressure for the layer represented by kth data level.  At the
!     lower bounding level of the lowest model layer, it uses the
!     surface pressure, unless the data set is pressure-level data, in
!     which case it assumes the lower bounding pressure level is as far
!     below the lowest vertical level as the upper bounding pressure
!     level is above.
SUBROUTINE DPFCALC(prs, sfp, pf, mix, mjy, mkzh, ter_follow)

    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(IN) :: prs
    REAL(KIND=8), DIMENSION(mix,mjy), INTENT(IN) :: sfp
    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(OUT) :: pf
    INTEGER, INTENT(IN) :: ter_follow,mix,mjy,mkzh

    INTEGER :: i,j,k
    
    !$OMP PARALLEL DO COLLAPSE(3) SCHEDULE(runtime)
    DO j = 1,mjy
        DO i = 1,mix
            DO k = 1,mkzh
                IF (k .EQ. mkzh) THEN
                    ! terrain-following data
                    IF (ter_follow .EQ. 1) THEN
                        pf(k,i,j) = sfp(i,j)
                    ! pressure-level data
                    ELSE
                        pf(k,i,j) = .5D0 * (3.D0*prs(k,i,j) - prs(k-1,i,j))
                    END IF
                ELSE
                    pf(k,i,j) = .5D0 * (prs(k+1,i,j) + prs(k,i,j))
                END IF
            END DO
        END DO
    END DO

    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DPFCALC

!======================================================================
!
! !IROUTINE: capecalc3d -- Calculate CAPE and CIN
!
! !DESCRIPTION:
!
!   This routine calculates CAPE and CIN (in m**2/s**2,
!   or J/kg) for every grid point in the entire 3D domain (treating
!   each grid point as a parcel).
!


! Important!  The z-indexes must be arranged so that mkzh (max z-index) is the
! surface pressure.  So, pressure must be ordered in ascending order before
! calling this routine.  Other variables must be ordered the same (p,tk,q,z).

! Also, be advised that missing data values are not checked during the computation.
! Also also, Pressure must be hPa

! NCLFORTSTART
SUBROUTINE DCAPECALC3D(prs,tmk,qvp,ght,ter,sfp,cape,cin,&
            prsf, prs_new, tmk_new, qvp_new, ght_new,&
            cmsg,mix,mjy,mkzh,ter_follow,&
            psafile, errstat, errmsg)
    USE wrf_constants, ONLY : CELKEL, G, EZERO, ESLCON1, ESLCON2, &
                          EPS, RD, CP, GAMMA, CPMD, RGASMD, GAMMAMD, TLCLC1, &
                          TLCLC2, TLCLC3, TLCLC4, THTECON1, THTECON2, THTECON3

    !USE omp_lib
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: cape, cin

    INTEGER, INTENT(IN) :: mix, mjy, mkzh, ter_follow
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(IN) :: prs
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(IN) :: tmk
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(IN) :: qvp
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(IN) :: ght
    REAL(KIND=8), DIMENSION(mix,mjy), INTENT(IN) :: ter
    REAL(KIND=8), DIMENSION(mix,mjy), INTENT(IN) ::sfp
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(OUT) :: cape
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(OUT) :: cin

    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(INOUT) :: prsf
    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(INOUT)  :: prs_new
    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(INOUT)  :: tmk_new
    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(INOUT)  :: qvp_new
    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(INOUT)  :: ght_new


    REAL(KIND=8), INTENT(IN) :: cmsg
    CHARACTER(LEN=*), INTENT(IN) :: psafile
    INTEGER, INTENT(INOUT) :: errstat
    CHARACTER(LEN=*), INTENT(INOUT) :: errmsg

! NCLFORTEND

    ! local variables
    INTEGER :: i, j, k, ilcl, kel, kk, klcl, klev, klfc, kmax, kpar
    REAL(KIND=8) :: tlcl, zlcl
    REAL(KIND=8) :: ethpari, qvppari, tmkpari
    REAL(KIND=8) :: facden, qvplift, tmklift, tvenv, tvlift, ghtlift
    REAL(KIND=8) :: eslift, tmkenv, qvpenv, tonpsadiabat
    REAL(KIND=8) :: benamin, dz
    ! Set a safety factor of 2*mkzh + 1 instead of previously chosen
    ! 150 levels
    REAL(KIND=8), DIMENSION(2*mkzh + 1) :: buoy, zrel, benaccum
    REAL(KIND=8), DIMENSION(150) :: psadithte, psadiprs
    REAL(KIND=8), DIMENSION(150,150) :: psaditmk
    LOGICAL :: elfound


    ! To remove compiler warnings
    tmkpari = 0
    qvppari = 0
    klev = 0
    klcl = 0
    kel = 0
    IF (.FALSE.) PRINT *,ter


    ! the comments were taken from a mark stoelinga email, 23 apr 2007,
    ! in response to a user getting the "outside of lookup table bounds"
    ! error message.

    ! tmkpari  - initial temperature of parcel, k
    !    values of 300 okay. (not sure how much from this you can stray.)

    ! prspari - initial pressure of parcel, hpa
    !    values of 980 okay. (not sure how much from this you can stray.)

    ! thtecon1, thtecon2, thtecon3
    !     these are all constants, the first in k and the other two have
    !     no units.  values of 3376, 2.54, and 0.81 were stated as being
    !     okay.

    ! tlcl - the temperature at the parcel's lifted condensation level, k
    !        should be a reasonable atmospheric temperature around 250-300 k
    !        (398 is "way too high")

    ! qvppari - the initial water vapor mixing ratio of the parcel,
    !           kg/kg (should range from 0.000 to 0.025)
    !

    !  calculated the pressure at full sigma levels (a set of pressure
    !  levels that bound the layers represented by the vertical grid points)

    !$OMP PARALLEL DO COLLAPSE(3) SCHEDULE(runtime)
    DO j = 1,mjy
        DO i = 1,mix
            DO k = 1,mkzh
                prs_new(k,i,j) = prs(i,j,k)
                tmk_new(k,i,j) = tmk(i,j,k)
                qvp_new(k,i,j) = qvp(i,j,k)
                ght_new(k,i,j) = ght(i,j,k)
            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO
    
    CALL DPFCALC(prs_new, sfp, prsf, mix, mjy, mkzh, ter_follow)

    !  before looping, set lookup table for getting temperature on
    !  a pseudoadiabat.

    CALL DLOOKUP_TABLE(psadithte, psadiprs, psaditmk, psafile, errstat, errmsg)

    IF (errstat .NE. 0) THEN
        RETURN
    END IF

    !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(tlcl, ethpari, &
    !$OMP zlcl, kk, ilcl, klcl, tmklift, tvenv, tvlift, ghtlift, &
    !$OMP facden, tmkenv, qvpenv, eslift, qvplift, buoy, benamin, &
    !$OMP benaccum, zrel, kmax, dz, elfound, &
    !$OMP kel, klfc, &
    !$OMP i, j, k, kpar) SCHEDULE(runtime)
    DO j = 1,mjy
        DO i = 1,mix
            cape(i,j,1) = 0.D0
            cin(i,j,1) = 0.D0
             
            !!$OMP SIMD
            DO kpar = 2, mkzh

                ! Calculate temperature and moisture properties of parcel
                ! (note, qvppari and tmkpari already calculated above for 2d case.)
             
                tlcl = TLCLC1/(LOG(tmk_new(kpar,i,j)**TLCLC2/(MAX(1.D-20,qvp_new(kpar,i,j)*prs_new(kpar,i,j)/ &
                       (EPS + qvp_new(kpar,i,j))))) - TLCLC3) + TLCLC4
             
                ethpari = tmk_new(kpar,i,j)*(1000.D0/prs_new(kpar,i,j))**(GAMMA*(1.D0 + GAMMAMD*qvp_new(kpar,i,j)))* &
                          EXP((THTECON1/tlcl - THTECON2)*qvp_new(kpar,i,j)*(1.D0 + THTECON3*qvp_new(kpar,i,j)))
                
                zlcl = ght_new(kpar,i,j) + (tmk_new(kpar,i,j) - tlcl)/(G/CP * (1.D0 + CPMD*qvp_new(kpar,i,j)))

                ! Calculate buoyancy and relative height of lifted parcel at
                ! all levels, and store in bottom up arrays.  add a level at the lcl,
                ! and at all points where buoyancy is zero.
                !
                ! For arrays that go bottom to top
                kk = 0
                ilcl = 0

                IF (ght_new(kpar,i,j) .GE. zlcl) THEN
                    ! Initial parcel already saturated or supersaturated.
                    ilcl = 2
                    klcl = 1
                END IF

                !!$OMP SIMD lastprivate(qvplift,tmklift,ghtlift,tvlift,tmkenv,qvpenv,tvenv,eslift,facden)
                DO k = kpar,1,-1
                    ! For arrays that go bottom to top
                    kk = kk + 1

                    ! Model level is below lcl
                    IF (ght_new(k,i,j) .LT. zlcl) THEN
                        tmklift = tmk_new(kpar,i,j) - G/(CP * (1.D0 + CPMD*qvp_new(kpar,i,j)))*&
                                  (ght_new(k,i,j) - ght_new(kpar,i,j))
                        tvenv = tmk_new(k,i,j)*(EPS + qvp_new(k,i,j))/(EPS*(1.D0 + qvp_new(k,i,j)))
                        tvlift = tmklift*(EPS + qvp_new(kpar,i,j))/(EPS*(1.D0 + qvp_new(kpar,i,j)))
                        ghtlift = ght_new(k,i,j)
                    ELSE IF (ght(i,j,k) .GE. zlcl .AND. ilcl .EQ. 0) THEN
                        ! This model level and previous model level straddle the lcl,
                        ! so first create a new level in the bottom-up array, at the lcl.
                        facden = 1.0/(ght_new(k,i,j) - ght_new(k+1,i,j))
                        tmkenv = tmk_new(k+1,i,j)*((ght_new(k,i,j)-zlcl)*facden) + tmk_new(k,i,j)*&
                                 ((zlcl-ght_new(k+1,i,j))*facden)
                        qvpenv = qvp_new(k+1,i,j)*((ght_new(k,i,j)-zlcl)*facden) + qvp_new(k,i,j)*&
                                 ((zlcl-ght_new(k+1,i,j))*facden)
                        tvenv = tmkenv* (EPS + qvpenv) / (EPS * (1.D0 + qvpenv))
                        tvlift = tlcl* (EPS + qvp_new(kpar,i,j)) / (EPS *(1.D0 + qvp_new(kpar,i,j)))
                        ghtlift = zlcl
                        ilcl = 1
                    ELSE
                        tmklift = TONPSADIABAT(ethpari, prs_new(k,i,j), psadithte, psadiprs,&
                                             psaditmk, GAMMA, errstat, errmsg)
                        eslift = EZERO*EXP(ESLCON1*(tmklift - CELKEL)/(tmklift - ESLCON2))
                        qvplift = EPS*eslift/(prs_new(k,i,j) - eslift)
                        tvenv = tmk_new(k,i,j) * (EPS + qvp_new(k,i,j)) / (EPS * (1.D0 + qvp_new(k,i,j)))
                        tvlift = tmklift*(EPS + qvplift) / (EPS * (1.D0 + qvplift))
                        ghtlift = ght_new(k,i,j)
                    END IF
                    ! Buoyancy
                    buoy(kk) = G*(tvlift - tvenv)/tvenv
                    zrel(kk) = ghtlift - ght_new(kpar,i,j)
                    IF ((kk .GT. 1) .AND. (buoy(kk)*buoy(kk-1) .LT. 0.0D0)) THEN
                        ! Parcel ascent curve crosses sounding curve, so create a new level
                        ! in the bottom-up array at the crossing.
                        kk = kk + 1
                        buoy(kk) = buoy(kk-1)
                        zrel(kk) = zrel(kk-1)
                        buoy(kk-1) = 0.D0
                        zrel(kk-1) = zrel(kk-2) + buoy(kk-2)/&
                                     (buoy(kk-2) - buoy(kk))*(zrel(kk) - zrel(kk-2))
                    END IF
                    IF (ilcl .EQ. 1) THEN
                        klcl = kk
                        ilcl = 2
                        CYCLE
                    END IF

                END DO
              
                kmax = kk
                ! IF (kmax .GT. 150) THEN
                !      print *,'kmax got too big'
                !     errstat = ALGERR
                !     WRITE(errmsg, *) 'capecalc3d: kmax got too big. kmax=',kmax
                !     RETURN
                ! END IF

                ! If no lcl was found, set klcl to kmax.  it is probably not really
                ! at kmax, but this will make the rest of the routine behave
                ! properly.
                IF (ilcl .EQ. 0) klcl=kmax

                ! Get the accumulated buoyant energy from the parcel's starting
                ! point, at all levels up to the top level.
                benaccum(1) = 0.0D0
                benamin = 9d9
                DO k = 2,kmax
                    dz = zrel(k) - zrel(k-1)
                    benaccum(k) = benaccum(k-1) + .5D0*dz*(buoy(k-1) + buoy(k))
                    IF (benaccum(k) .LT. benamin) THEN
                        benamin = benaccum(k)
                    END IF
                END DO
                ! Determine equilibrium level (el), which we define as the highest
                ! level of non-negative buoyancy above the lcl. note, this may be
                ! the top level if the parcel is still buoyant there.

                elfound = .FALSE.
                DO k = kmax,klcl,-1
                    IF (buoy(k) .GE. 0.D0) THEN
                        ! k of equilibrium level
                        kel = k
                        elfound = .TRUE.
                        EXIT
                    END IF
                END DO

                ! If we got through that loop, then there is no non-negative
                ! buoyancy above the lcl in the sounding.  in these situations,
                ! both cape and cin will be set to -0.1 j/kg. (see below about
                ! missing values in v6.1.0). also, where cape is
                ! non-zero, cape and cin will be set to a minimum of +0.1 j/kg, so
                ! that the zero contour in either the cin or cape fields will
                ! circumscribe regions of non-zero cape.

                ! In v6.1.0 of ncl, we added a _fillvalue attribute to the return
                ! value of this function. at that time we decided to change -0.1
                ! to a more appropriate missing value, which is passed into this
                ! routine as cmsg.

                IF (.NOT. elfound) THEN
                    !print *,'el not found'
                    cape(i,j,kpar) = cmsg
                    cin(i,j,kpar)  = cmsg
                    klfc = kmax
                    CYCLE
                END IF

                ! If there is an equilibrium level, then cape is positive.  we'll
                ! define the level of free convection (lfc) as the point below the
                ! el, but at or above the lcl, where accumulated buoyant energy is a
                ! minimum.  the net positive area (accumulated buoyant energy) from
                ! the lfc up to the el will be defined as the cape, and the net
                ! negative area (negative of accumulated buoyant energy) from the
                ! parcel starting point to the lfc will be defined as the convective
                !  inhibition (cin).

                ! First get the lfc according to the above definition.
                benamin = 9D9
                klfc = kmax
                DO k = klcl,kel
                    IF (benaccum(k) .LT. benamin) THEN
                        benamin = benaccum(k)
                        klfc = k
                    END IF
                END DO

                ! Now we can assign values to cape and cin

                cape(i,j,kpar) = MAX(benaccum(kel)-benamin, 0.1D0)
                cin(i,j,kpar) = MAX(-benamin, 0.1D0)

                ! cin is uninteresting when cape is small (< 100 j/kg), so set
                ! cin to -0.1 (see note about missing values in v6.1.0) in
                ! that case.

                ! In v6.1.0 of ncl, we added a _fillvalue attribute to the return
                ! value of this function. at that time we decided to change -0.1
                ! to a more appropriate missing value, which is passed into this
                ! routine as cmsg.

                IF (cape(i,j,kpar) .LT. 100.D0) cin(i,j,kpar) = cmsg

            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN
END SUBROUTINE DCAPECALC3D

!======================================================================
!
! !IROUTINE: capecalc2d -- Calculate CAPE and CIN
!
! !DESCRIPTION:
!
!   Calculates CAPE and CIN only for the parcel with max theta-e in
!   the column, (i.e. something akin to Colman's MCAPE).  By "parcel",
!   we mean a 500-m deep parcel, with actual temperature and moisture
!   averaged over that depth.
!
!   CAPE and CIN are 2D fields that are placed in the k=mkzh slabs of
!   the cape and cin arrays.  Also, LCL and LFC heights
!   are put in the k=mkzh-1 and k=mkzh-2 slabs of the cin array.
!
! Important!  The z-indexes must be arranged so that mkzh (max z-index) is the
! surface pressure.  So, pressure must be ordered in ascending order before
! calling this routine.  Other variables must be ordered the same (p,tk,q,z).

! Also, be advised that missing data values are not checked during the
! computation.
! Also also, Pressure must be hPa

! NCLFORTSTART
SUBROUTINE DCAPECALC2D(prs,tmk,qvp,ght,ter,sfp,cape,cin,&
            prsf, prs_new, tmk_new, qvp_new, ght_new,&
            cmsg,mix,mjy,mkzh,ter_follow,&
            psafile, errstat, errmsg)
    USE wrf_constants, ONLY : CELKEL, G, EZERO, ESLCON1, ESLCON2, &
                          EPS, RD, CP, GAMMA, CPMD, RGASMD, GAMMAMD, TLCLC1, &
                          TLCLC2, TLCLC3, TLCLC4, THTECON1, THTECON2, THTECON3

    !USE omp_lib
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: cape, cin

    INTEGER, INTENT(IN) :: mix, mjy, mkzh, ter_follow
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(IN) :: prs
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(IN) :: tmk
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(IN) :: qvp
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(IN) :: ght
    REAL(KIND=8), DIMENSION(mix,mjy), INTENT(IN) :: ter
    REAL(KIND=8), DIMENSION(mix,mjy), INTENT(IN) ::sfp
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(OUT) :: cape
    REAL(KIND=8), DIMENSION(mix,mjy,mkzh), INTENT(OUT) :: cin

    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(INOUT) :: prsf
    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(INOUT) :: prs_new
    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(INOUT) :: tmk_new
    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(INOUT) :: qvp_new
    REAL(KIND=8), DIMENSION(mkzh,mix,mjy), INTENT(INOUT) :: ght_new

    REAL(KIND=8), INTENT(IN) :: cmsg
    CHARACTER(LEN=*), INTENT(IN) :: psafile
    INTEGER, INTENT(INOUT) :: errstat
    CHARACTER(LEN=*), INTENT(INOUT) :: errmsg

! NCLFORTEND


    ! local variables
    INTEGER :: i, j, k, ilcl, kel, kk, klcl, klev, klfc, kmax, kpar, kpar1, kpar2
    REAL(KIND=8) :: ethmax, p, e, tlcl, zlcl
    REAL(KIND=8) :: pavg, tvirtual, p1, p2, pp1, pp2, th, totthe, totqvp, totprs
    REAL(KIND=8) :: cpm, deltap, ethpari, gammam, qvppari, tmkpari
    REAL(KIND=8) :: facden, qvplift, tmklift, tvenv, tvlift, ghtlift
    REAL(KIND=8) :: eslift, tmkenv, qvpenv, tonpsadiabat
    REAL(KIND=8) :: benamin, dz, pup, pdn
    ! Set a safety factor of 2*mkzh + 1 instead of previously chosen
    ! 150 levels
    REAL(KIND=8), DIMENSION(2*mkzh + 1) :: buoy, zrel, benaccum
    REAL(KIND=8), DIMENSION(150) :: psadithte, psadiprs
    REAL(KIND=8), DIMENSION(150,150) :: psaditmk
    LOGICAL :: elfound
    REAL(KIND=8), DIMENSION(mkzh) :: eth_temp


    ! To remove compiler warnings
    errstat = 0
    tmkpari = 0
    qvppari = 0
    klev = 0
    klcl = 0
    kel = 0
    deltap = 0


    ! the comments were taken from a mark stoelinga email, 23 apr 2007,
    ! in response to a user getting the "outside of lookup table bounds"
    ! error message.

    ! tmkpari  - initial temperature of parcel, k
    !    values of 300 okay. (not sure how much from this you can stray.)

    ! prspari - initial pressure of parcel, hpa
    !    values of 980 okay. (not sure how much from this you can stray.)

    ! thtecon1, thtecon2, thtecon3
    !     these are all constants, the first in k and the other two have
    !     no units.  values of 3376, 2.54, and 0.81 were stated as being
    !     okay.

    ! tlcl - the temperature at the parcel's lifted condensation level, k
    !        should be a reasonable atmospheric temperature around 250-300 k
    !        (398 is "way too high")

    ! qvppari - the initial water vapor mixing ratio of the parcel,
    !           kg/kg (should range from 0.000 to 0.025)
    !

    !$OMP PARALLEL DO COLLAPSE(3) SCHEDULE(runtime)
    DO j = 1,mjy
        DO i = 1,mix
            DO k = 1,mkzh
                prs_new(k,i,j) = prs(i,j,k)
                tmk_new(k,i,j) = tmk(i,j,k)
                qvp_new(k,i,j) = qvp(i,j,k)
                ght_new(k,i,j) = ght(i,j,k)
            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO


    !  calculated the pressure at full sigma levels (a set of pressure
    !  levels that bound the layers represented by the vertical grid points)
    CALL DPFCALC(prs_new, sfp, prsf, mix, mjy, mkzh, ter_follow)

    !  before looping, set lookup table for getting temperature on
    !  a pseudoadiabat.

    CALL DLOOKUP_TABLE(psadithte, psadiprs, psaditmk, psafile, errstat, errmsg)

    IF (errstat .NE. 0) THEN
        RETURN
    END IF

    !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(tlcl, ethpari, &
    !$OMP zlcl, kk, ilcl, klcl, tmklift, tvenv, tvlift, ghtlift, &
    !$OMP facden, tmkenv, qvpenv, eslift, qvplift, buoy, benamin, &
    !$OMP benaccum, zrel, kmax, dz, elfound, gammam, cpm, e, &
    !$OMP kel, klfc, pavg, p2, p1, totthe, totqvp, totprs, &
    !$OMP i, j, k, kpar, kpar1, kpar2, qvppari, tmkpari, p, pup, pdn, th, &
    !$OMP pp1, pp2, ethmax, eth_temp, klev) SCHEDULE(runtime)
    DO j = 1,mjy
        DO i = 1,mix
            cape(i,j,1) = 0.D0
            cin(i,j,1) = 0.D0
            ! find parcel with max theta-e in lowest 3 km agl.
            ethmax = -1.D0
            eth_temp = -1.D0
            DO k = 1, mkzh
                IF (ght_new(k,i,j)-ter(i,j) .LT. 3000.D0) THEN
                    tlcl = TLCLC1 / (LOG(tmk_new(k,i,j)**TLCLC2/&
                           (MAX(qvp_new(k,i,j), 1.d-15)*prs_new(k,i,j)/(EPS+MAX(qvp_new(k,i,j), 1.d-15))))-TLCLC3)+&
                           TLCLC4
                    eth_temp(k) = tmk_new(k,i,j) * (1000.D0/prs_new(k,i,j))**&
                                  (GAMMA*(1.D0 + GAMMAMD*(MAX(qvp_new(k,i,j), 1.d-15))))*&
                                  EXP((THTECON1/tlcl - THTECON2)*(MAX(qvp_new(k,i,j), 1.d-15))*&
                                  (1.D0 + THTECON3*(MAX(qvp_new(k,i,j), 1.d-15))))
                END IF
            END DO
            klev = mkzh
            DO k = 1,mkzh
                IF (eth_temp(k) .GT. ethmax) THEN
                    klev = k
                    ethmax = eth_temp(k)
                END IF
            END DO

            kpar1 = klev
            kpar2 = klev


            ! Establish average properties of that parcel
            ! (over depth of approximately davg meters)

            !davg = 500.D0
            pavg = 500.D0 * prs_new(kpar1,i,j)*&
                   G/(RD*tvirtual(tmk_new(kpar1,i,j), qvp_new(kpar1,i,j)))
            p2 = MIN(prs_new(kpar1,i,j)+.5d0*pavg, prsf(mkzh,i,j))
            p1 = p2 - pavg
            totthe = 0.D0
            totqvp = 0.D0
            totprs = 0.D0
            DO k = mkzh,2,-1
                IF (prsf(k,i,j) .LE. p1) EXIT !GOTO 35
                IF (prsf(k-1,i,j) .GE. p2) CYCLE !GOTO 34
                p = prs_new(k,i,j)
                pup = prsf(k,i,j)
                pdn = prsf(k-1,i,j)
                !q = MAX(qvp_new(k,i,j),1.D-15)
                th = tmk_new(k,i,j)*(1000.D0/prs_new(k,i,j))**(GAMMA*(1.D0 + GAMMAMD*MAX(qvp_new(k,i,j),1.D-15)))
                pp1 = MAX(p1,pdn)
                pp2 = MIN(p2,pup)
                IF (pp2 .GT. pp1) THEN
                    ! deltap = pp2 - pp1
                    totqvp = totqvp + MAX(qvp_new(k,i,j),1.D-15)*(pp2 - pp1)
                    totthe = totthe + th*(pp2 - pp1)
                    totprs = totprs + (pp2 - pp1)
                END IF
            END DO
            qvppari = totqvp/totprs
            tmkpari = (totthe/totprs)*&
                      (prs_new(kpar1,i,j)/1000.D0)**(GAMMA*(1.D0+GAMMAMD*qvp_new(kpar1,i,j)))

            DO kpar = kpar1, kpar2

                ! Calculate temperature and moisture properties of parcel
                ! (note, qvppari and tmkpari already calculated above for 2d
                ! case.)

                !prspari = prs_new(kpar,i,j)
                !ghtpari = ght_new(kpar,i,j)
                gammam = GAMMA * (1.D0 + GAMMAMD*qvppari)
                cpm = CP * (1.D0 + CPMD*qvppari)

                e = MAX(1.D-20,qvppari*prs_new(kpar,i,j)/(EPS + qvppari))
                tlcl = TLCLC1/(LOG(tmkpari**TLCLC2/e) - TLCLC3) + TLCLC4
                ethpari = tmkpari*(1000.D0/prs_new(kpar,i,j))**(GAMMA*(1.D0 + GAMMAMD*qvppari))*&
                          EXP((THTECON1/tlcl - THTECON2)*qvppari*(1.D0 + THTECON3*qvppari))
                zlcl = ght_new(kpar,i,j) + (tmkpari - tlcl)/(G/cpm)

                ! Calculate buoyancy and relative height of lifted parcel at
                ! all levels, and store in bottom up arrays.  add a level at the
                ! lcl,
                ! and at all points where buoyancy is zero.
                !
                !
                ! For arrays that go bottom to top
                kk = 0
                ilcl = 0

                IF (ght_new(kpar,i,j) .GE. zlcl) THEN
                    ! Initial parcel already saturated or supersaturated.
                    ilcl = 2
                    klcl = 1
                END IF

                k = kpar
                DO k = kpar,1,-1
                    ! For arrays that go bottom to top
                    kk = kk + 1

                    ! Model level is below lcl
                    IF (ght_new(k,i,j) .LT. zlcl) THEN
                        tmklift = tmk_new(kpar,i,j) - G/(CP * (1.D0 + CPMD*qvp_new(kpar,i,j)))*&
                                  (ght_new(k,i,j) - ght_new(kpar,i,j))
                        tvenv = tmk_new(k,i,j)*(EPS + qvp_new(k,i,j))/(EPS*(1.D0 + qvp_new(k,i,j)))
                        tvlift = tmklift*(EPS + qvp_new(kpar,i,j))/(EPS*(1.D0 + qvp_new(kpar,i,j)))
                        ghtlift = ght_new(k,i,j)
                    ELSE IF (ght(i,j,k) .GE. zlcl .AND. ilcl .EQ. 0) THEN
                        ! This model level and previous model level straddle the lcl,
                        ! so first create a new level in the bottom-up array, at the lcl.
                        facden = 1/(ght_new(k,i,j) - ght_new(k+1,i,j))
                        tmkenv = tmk_new(k+1,i,j)*((ght_new(k,i,j)-zlcl)*facden) + tmk_new(k,i,j)*&
                                 ((zlcl-ght_new(k+1,i,j))*facden)
                        qvpenv = qvp_new(k+1,i,j)*((ght_new(k,i,j)-zlcl)*facden) + qvp_new(k,i,j)*&
                                 ((zlcl-ght_new(k+1,i,j))*facden)
                        tvenv = tmkenv* (EPS + qvpenv) / (EPS * (1.D0 + qvpenv))
                        tvlift = tlcl* (EPS + qvp_new(kpar,i,j)) / (EPS *(1.D0 + qvp_new(kpar,i,j)))
                        ghtlift = zlcl
                        ilcl = 1
                    ELSE
                        tmklift = TONPSADIABAT(ethpari, prs_new(k,i,j), psadithte, psadiprs,&
                                               psaditmk, GAMMA, errstat, errmsg)
                        eslift = EZERO*EXP(ESLCON1*(tmklift - CELKEL)/(tmklift - ESLCON2))
                        qvplift = EPS*eslift/(prs_new(k,i,j) - eslift)
                        tvenv = tmk_new(k,i,j) * (EPS + qvp_new(k,i,j)) / (EPS * (1.D0 + qvp_new(k,i,j)))
                        tvlift = tmklift*(EPS + qvplift) / (EPS * (1.D0 + qvplift))
                        ghtlift = ght_new(k,i,j)
                    END IF
                    ! Buoyancy
                    buoy(kk) = G*(tvlift - tvenv)/tvenv
                    zrel(kk) = ghtlift - ght_new(kpar,i,j)
                    IF ((kk .GT. 1) .AND. (buoy(kk)*buoy(kk-1) .LT. 0.0D0)) THEN
                        ! Parcel ascent curve crosses sounding curve, so create a new level
                        ! in the bottom-up array at the crossing.
                        kk = kk + 1
                        buoy(kk) = buoy(kk-1)
                        zrel(kk) = zrel(kk-1)
                        buoy(kk-1) = 0.D0
                        zrel(kk-1) = zrel(kk-2) + buoy(kk-2)/&
                                     (buoy(kk-2) - buoy(kk))*(zrel(kk) - zrel(kk-2))
                    END IF
                    IF (ilcl .EQ. 1) THEN
                        klcl = kk
                        ilcl = 2
                        CYCLE
                    END IF
                END DO

                kmax = kk
                ! IF (kmax .GT. 150) THEN
                !     errstat = ALGERR
                !     WRITE(errmsg, *) 'capecalc3d: kmax got too big. kmax=',kmax
                !     RETURN
                ! END IF

                ! If no lcl was found, set klcl to kmax.  it is probably not
                ! really
                ! at kmax, but this will make the rest of the routine behave
                ! properly.
                IF (ilcl .EQ. 0) klcl=kmax

                ! Get the accumulated buoyant energy from the parcel's starting
                ! point, at all levels up to the top level.
                benaccum(1) = 0.0D0
                benamin = 9d9
                DO k = 2,kmax
                    dz = zrel(k) - zrel(k-1)
                    benaccum(k) = benaccum(k-1) + .5D0*dz*(buoy(k-1) + buoy(k))
                    IF (benaccum(k) .LT. benamin) THEN
                        benamin = benaccum(k)
                    END IF
                END DO
                ! Determine equilibrium level (el), which we define as the highest
                ! level of non-negative buoyancy above the lcl. note, this may be
                ! the top level if the parcel is still buoyant there.

                elfound = .FALSE.
                DO k = kmax,klcl,-1
                    IF (buoy(k) .GE. 0.D0) THEN
                        ! k of equilibrium level
                        kel = k
                        elfound = .TRUE.
                        EXIT
                    END IF
                END DO

                ! If we got through that loop, then there is no non-negative
                ! buoyancy above the lcl in the sounding.  in these situations,
                ! both cape and cin will be set to -0.1 j/kg. (see below about
                ! missing values in v6.1.0). also, where cape is
                ! non-zero, cape and cin will be set to a minimum of +0.1 j/kg, so
                ! that the zero contour in either the cin or cape fields will
                ! circumscribe regions of non-zero cape.
                ! In v6.1.0 of ncl, we added a _fillvalue attribute to the return
                ! value of this function. at that time we decided to change -0.1
                ! to a more appropriate missing value, which is passed into this
                ! routine as cmsg.

                IF (.NOT. elfound) THEN
                    cape(i,j,kpar) = cmsg
                    cin(i,j,kpar)  = cmsg
                    klfc = kmax
                    CYCLE
                END IF


                ! If there is an equilibrium level, then cape is positive.
                ! we'll
                ! define the level of free convection (lfc) as the point below
                ! the
                ! el, but at or above the lcl, where accumulated buoyant energy
                ! is a
                ! minimum.  the net positive area (accumulated buoyant energy)
                ! from
                ! the lfc up to the el will be defined as the cape, and the net
                ! negative area (negative of accumulated buoyant energy) from
                ! the
                ! parcel starting point to the lfc will be defined as the
                ! convective
                ! inhibition (cin).

                ! First get the lfc according to the above definition.
                benamin = 9D9
                klfc = kmax
                DO k = klcl,kel
                    IF (benaccum(k) .LT. benamin) THEN
                        benamin = benaccum(k)
                        klfc = k
                    END IF
                END DO

                ! Now we can assign values to cape and cin

                cape(i,j,kpar) = MAX(benaccum(kel)-benamin, 0.1D0)
                cin(i,j,kpar) = MAX(-benamin, 0.1D0)

                ! cin is uninteresting when cape is small (< 100 j/kg), so set
                ! cin to -0.1 (see note about missing values in v6.1.0) in
                ! that case.

                ! In v6.1.0 of ncl, we added a _fillvalue attribute to the return
                ! value of this function. at that time we decided to change -0.1
                ! to a more appropriate missing value, which is passed into this
                ! routine as cmsg.

                IF (cape(i,j,kpar) .LT. 100.D0) cin(i,j,kpar) = cmsg

            END DO

            cape(i,j,mkzh) = cape(i,j,kpar1)
            cin(i,j,mkzh) = cin(i,j,kpar1)
            ! meters agl
            cin(i,j,mkzh-1) = zrel(klcl) + ght_new(kpar1,i,j) - ter(i,j)
            ! meters agl
            cin(i,j,mkzh-2) = zrel(klfc) + ght_new(kpar1,i,j) - ter(i,j)

        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN
END SUBROUTINE DCAPECALC2D

! These are chosen to match the wrf module_model_constants.F where
! applicable
MODULE wrf_constants
    INTEGER, PARAMETER :: ERRLEN=512
    INTEGER, PARAMETER :: ALGERR=64

    REAL(KIND=8), PARAMETER :: WRF_EARTH_RADIUS = 6370000.D0
    REAL(KIND=8), PARAMETER :: T_BASE = 300.0D0
    REAL(KIND=8), PARAMETER :: PI = 3.1415926535897932384626433D0
    REAL(KIND=8), PARAMETER :: RAD_PER_DEG = PI/180.D0
    REAL(KIND=8), PARAMETER :: DEG_PER_RAD = 180.D0/PI
    REAL(KIND=8), PARAMETER :: DEFAULT_FILL = 9.9692099683868690D36
    INTEGER(KIND=1), PARAMETER :: DEFAULT_FILL_INT8 = -127
    INTEGER(KIND=2), PARAMETER :: DEFAULT_FILL_INT16 = -32767
    INTEGER(KIND=4), PARAMETER :: DEFAULT_FILL_INT32 = -2147483647
    INTEGER(KIND=8), PARAMETER :: DEFAULT_FILL_INT64 = INT(-9223372036854775806D0, KIND=8)
    REAL(KIND=4), PARAMETER :: DEFAULT_FILL_FLOAT = 9.9692099683868690E36
    REAL(KIND=8), PARAMETER :: DEFAULT_FILL_DOUBLE = 9.9692099683868690D36
    CHARACTER(LEN=1), PARAMETER :: DEFAULT_FILL_CHAR = ACHAR(0)


    REAL(KIND=8), PARAMETER :: P1000MB = 100000.D0
    ! j/k/kg
    REAL(KIND=8), PARAMETER :: RD = 287.D0
    REAL(KIND=8), PARAMETER :: RV = 461.6D0
    !REAL(KIND=8), PARAMETER :: RV = 461.5D0
    !  j/k/kg  note: not using bolton's value of 1005.7
    REAL(KIND=8), PARAMETER :: CP = 1004.5D0
    !REAL(KIND=8), PARAMETER :: CP = 1004D0

    REAL(KIND=8), PARAMETER :: G = 9.81D0
    REAL(KIND=8), PARAMETER :: USSALR = 0.0065D0  ! deg C per m

    REAL(KIND=8), PARAMETER :: CELKEL = 273.15D0
    REAL(KIND=8), PARAMETER :: CELKEL_TRIPLE = 273.16D0
    !REAL(KIND=8), PARAMETER :: GRAV = 9.81D0
    ! hpa
    REAL(KIND=8), PARAMETER :: EZERO = 6.112D0
    REAL(KIND=8), PARAMETER :: ESLCON1 = 17.67D0
    REAL(KIND=8), PARAMETER :: ESLCON2 = 29.65D0
    REAL(KIND=8), PARAMETER :: EPS = 0.622D0
    REAL(KIND=8), PARAMETER :: GAMMA = RD/CP
    !  cp_moist=cp*(1.+cpmd*qvp)
    REAL(KIND=8), PARAMETER :: CPMD = .887D0
    !  rgas_moist=rgas*(1.+rgasmd*qvp)
    REAL(KIND=8), PARAMETER :: RGASMD = .608D0
    !  gamma_moist=gamma*(1.+gammamd*qvp)
    REAL(KIND=8), PARAMETER :: GAMMAMD = RGASMD - CPMD
    REAL(KIND=8), PARAMETER :: TLCLC1 = 2840.D0
    REAL(KIND=8), PARAMETER :: TLCLC2 = 3.5D0
    REAL(KIND=8), PARAMETER :: TLCLC3 = 4.805D0
    REAL(KIND=8), PARAMETER :: TLCLC4 = 55.D0
    !  k
    REAL(KIND=8), PARAMETER :: THTECON1 = 3376.D0
    REAL(KIND=8), PARAMETER :: THTECON2 = 2.54D0
    REAL(KIND=8), PARAMETER :: THTECON3 = .81D0

    REAL(KIND=8), PARAMETER :: ABSCOEFI = .272D0  ! cloud ice absorption coefficient in m^2/g
    REAL(KIND=8), PARAMETER :: ABSCOEF = .145D0   ! cloud water absorption coefficient in m^2/g

    REAL(KIND=8), PARAMETER :: GAMMA_SEVEN = 720.D0
    REAL(KIND=8), PARAMETER :: RHOWAT = 1000.D0
    REAL(KIND=8), PARAMETER :: RHO_R = RHOWAT
    REAL(KIND=8), PARAMETER :: RHO_S = 100.D0
    REAL(KIND=8), PARAMETER :: RHO_G = 400.D0
    REAL(KIND=8), PARAMETER :: ALPHA = 0.224D0

    REAL(KIND=8), PARAMETER :: SCLHT = RD*256.D0/G
    REAL(KIND=8), PARAMETER :: EXPON =  RD*USSALR/G
    REAL(KIND=8), PARAMETER :: EXPONI =  1./EXPON


END MODULE wrf_constants

!     This routine computes equivalent reflectivity factor (in dBZ) at
!     each model grid point.  In calculating Ze, the RIP algorithm makes
!     assumptions consistent with those made in an early version
!     (ca. 1996) of the bulk mixed-phase microphysical scheme in the MM5
!     model (i.e., the scheme known as "Resiner-2").  For each species:
!
!     1. Particles are assumed to be spheres of constant density.  The
!     densities of rain drops, snow particles, and graupel particles are
!     taken to be rho_r = rho_l = 1000 kg m^-3, rho_s = 100 kg m^-3, and
!     rho_g = 400 kg m^-3, respectively. (l refers to the density of
!     liquid water.)
!
!     2. The size distribution (in terms of the actual diameter of the
!     particles, rather than the melted diameter or the equivalent solid
!     ice sphere diameter) is assumed to follow an exponential
!     distribution of the form N(D) = N_0 * exp( lambda*D ).
!
!     3. If ivarint=0, the intercept parameters are assumed constant
!     (as in early Reisner-2), with values of 8x10^6, 2x10^7,
!     and 4x10^6 m^-4, for rain, snow, and graupel, respectively.
!     If ivarint=1, variable intercept parameters are used, as
!     calculated in Thompson, Rasmussen, and Manning (2004, Monthly
!     Weather Review, Vol. 132, No. 2, pp. 519-542.)
!
!     4. If iliqskin=1, frozen particles that are at a temperature above
!     freezing are assumed to scatter as a liquid particle.
!
!     More information on the derivation of simulated reflectivity in
!     RIP can be found in Stoelinga (2005, unpublished write-up).
!     Contact Mark Stoelinga (stoeling@atmos.washington.edu) for a copy.

!NCLFORTSTART
SUBROUTINE CALCDBZ(prs, tmk, qvp, qra, qsn, qgr, sn0, ivarint, iliqskin, dbz, nx, ny, nz)
    USE wrf_constants, ONLY : GAMMA_SEVEN, RHOWAT, RHO_R, RHO_S, RHO_G, ALPHA, &
                          CELKEL, PI, RD

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: dbz

    !   Arguments
    INTEGER, INTENT(IN) :: nx, ny, nz
    INTEGER, INTENT(IN) :: sn0, ivarint, iliqskin
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(OUT) :: dbz
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: prs
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: tmk
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(INOUT) :: qvp
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(INOUT) :: qra
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(INOUT) :: qsn
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(INOUT) :: qgr

!NCLEND

    !   Local Variables
    INTEGER :: i, j, k
    REAL(KIND=8) :: temp_c, virtual_t
    REAL(KIND=8) :: gonv, ronv, sonv
    REAL(KIND=8) :: factor_g, factor_r, factor_s
    REAL(KIND=8) :: factorb_g, factorb_s
    REAL(KIND=8) :: rhoair, z_e

    !   Constants used to calculate variable intercepts
    REAL(KIND=8), PARAMETER :: R1 = 1.D-15
    REAL(KIND=8), PARAMETER :: RON = 8.D6
    REAL(KIND=8), PARAMETER :: RON2 = 1.D10
    REAL(KIND=8), PARAMETER :: SON = 2.D7
    REAL(KIND=8), PARAMETER :: GON = 5.D7
    REAL(KIND=8), PARAMETER :: RON_MIN = 8.D6
    REAL(KIND=8), PARAMETER :: RON_QR0 = 0.00010D0
    REAL(KIND=8), PARAMETER :: RON_DELQR0 = 0.25D0*RON_QR0
    REAL(KIND=8), PARAMETER :: RON_CONST1R = (RON2-RON_MIN)*0.5D0
    REAL(KIND=8), PARAMETER :: RON_CONST2R = (RON2+RON_MIN)*0.5D0

    !   Constant intercepts
    REAL(KIND=8), PARAMETER :: RN0_R = 8.D6
    REAL(KIND=8), PARAMETER :: RN0_S = 2.D7
    REAL(KIND=8), PARAMETER :: RN0_G = 4.D6

    !$OMP PARALLEL

    !   Force all Q arrays to be 0.0 or greater.
    !$OMP DO COLLAPSE(3) SCHEDULE(runtime)
    DO k = 1,nz
        DO j = 1,ny
            DO i = 1,nx
                IF (qvp(i,j,k) .LT. 0.0) THEN
                    qvp(i,j,k) = 0.0
                END IF
                IF (qra(i,j,k) .LT. 0.0) THEN
                    qra(i,j,k) = 0.0
                END IF
                IF (qsn(i,j,k) .LT. 0.0) THEN
                    qsn(i,j,k) = 0.0
                END IF
                IF (qgr(i,j,k) .LT. 0.0) THEN
                    qgr(i,j,k) = 0.0
                END IF
            END DO
        END DO
    END DO
    !$OMP END DO

    !   Input pressure is Pa, but we need hPa in calculations

    IF (sn0 .EQ. 0) THEN
        !$OMP DO COLLAPSE(3) SCHEDULE(runtime)
        DO k = 1,nz
            DO j = 1,ny
                DO i = 1,nx
                    IF (tmk(i,j,k) .LT. CELKEL) THEN
                        qsn(i,j,k) = qra(i,j,k)
                        qra(i,j,k) = 0.D0
                    END IF
                END DO
            END DO
        END DO
        !$OMP END DO
    END IF

    factor_r = GAMMA_SEVEN*1.D18*(1.D0/(PI*RHO_R))**1.75D0
    factor_s = GAMMA_SEVEN*1.D18*(1.D0/(PI*RHO_S))**1.75D0*(RHO_S/RHOWAT)**2*ALPHA
    factor_g = GAMMA_SEVEN*1.D18*(1.D0/(PI*RHO_G))**1.75D0*(RHO_G/RHOWAT)**2*ALPHA


    !$OMP DO COLLAPSE(3) PRIVATE(i, j, k, temp_c, virtual_t, gonv, ronv, sonv, &
    !$OMP factorb_g, factorb_s, rhoair, z_e) &
    !$OMP FIRSTPRIVATE(factor_r, factor_s, factor_g) SCHEDULE(runtime)
    DO k = 1,nz
        DO j = 1,ny
            DO i = 1,nx
                virtual_t = tmk(i,j,k)*(0.622D0 + qvp(i,j,k))/(0.622D0*(1.D0 + qvp(i,j,k)))
                rhoair = prs(i,j,k)/(RD*virtual_t)

                ! Adjust factor for brightband, where snow or graupel particle
                ! scatters like liquid water (alpha=1.0) because it is assumed to
                ! have a liquid skin.
                IF (iliqskin .EQ. 1 .AND. tmk(i,j,k) .GT. CELKEL) THEN
                    factorb_s = factor_s/ALPHA
                    factorb_g = factor_g/ALPHA
                ELSE
                    factorb_s = factor_s
                    factorb_g = factor_g
                END IF

                ! Calculate variable intercept parameters
                IF (ivarint .EQ. 1) THEN

                    temp_c = MIN(-0.001D0, tmk(i,j,k)-CELKEL)
                    sonv = MIN(2.0D8, 2.0D6*EXP(-0.12D0*temp_c))

                    gonv = gon
                    IF (qgr(i,j,k) .GT. R1) THEN
                        gonv = 2.38D0 * (PI*RHO_G/(rhoair*qgr(i,j,k)))**0.92D0
                        gonv = MAX(1.D4, MIN(gonv,GON))
                    END IF

                    ronv = RON2
                    IF (qra(i,j,k) .GT. R1) THEN
                        ronv = RON_CONST1R*TANH((RON_QR0 - qra(i,j,k))/RON_DELQR0) + RON_CONST2R
                    END IF

                ELSE
                    ronv = RN0_R
                    sonv = RN0_S
                    gonv = RN0_G
                END IF

                ! Total equivalent reflectivity factor (z_e, in mm^6 m^-3) is
                ! the sum of z_e for each hydrometeor species:

                z_e = factor_r*(rhoair*qra(i,j,k))**1.75D0/ronv**.75D0 + &
                      factorb_s*(rhoair*qsn(i,j,k))**1.75D0/sonv**.75D0 + &
                      factorb_g*(rhoair*qgr(i,j,k))**1.75D0/gonv**.75D0

                ! Adjust small values of Z_e so that dBZ is no lower than -30
                z_e = MAX(z_e, .001D0)

                ! Convert to dBZ
                dbz(i,j,k) = 10.D0*LOG10(z_e)
            END DO
        END DO
    END DO
    !$OMP END DO

    !$OMP END PARALLEL

    RETURN

END SUBROUTINE CALCDBZ

! NCLFORTSTART
SUBROUTINE DCOMPUTEPI(pi, pressure, nx, ny, nz)
    USE wrf_constants, ONLY : P1000MB, RD, CP

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: pi

    INTEGER, INTENT(IN) :: nx, ny, nz
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(OUT) :: pi
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: pressure
! NCLEND

    INTEGER i, j, k

    !REAL(KIND=8), PARAMETER :: P1000MB=100000.D0, R_D=287.D0, CP=7.D0*R_D/2.D0

    !$OMP PARALLEL DO COLLAPSE(3) SCHEDULE(runtime)
    DO k = 1,nz
        DO j = 1,ny
            DO i = 1,nx
                pi(i,j,k) = (pressure(i,j,k)/P1000MB)**(RD/CP)
            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO

END SUBROUTINE DCOMPUTEPI

! Temperature from potential temperature in kelvin.
!NCLFORTSTART
SUBROUTINE DCOMPUTETK(tk, pressure, theta, nx)
    USE wrf_constants, ONLY : P1000MB, RD, CP

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: tk

    INTEGER, INTENT(IN) :: nx
    !REAL(KIND=8) :: pi
    REAL(KIND=8), DIMENSION(nx), INTENT(IN) :: pressure
    REAL(KIND=8), DIMENSION(nx), INTENT(IN) :: theta
    REAL(KIND=8), DIMENSION(nx), INTENT(OUT) :: tk

! NCLEND

    INTEGER :: i

    !REAL(KIND=8), PARAMETER :: P1000MB=100000.D0, RD=287.D0, CP=7.D0*RD/2.D0

    !$OMP PARALLEL DO SCHEDULE(runtime)
    DO i = 1,nx
        !pi = (pressure(i)/P1000MB)**(RD/CP)
        !tk(i) = pi * theta(i)
        tk(i) = (pressure(i)/P1000MB)**(RD/CP) * theta(i)
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DCOMPUTETK


! NCLFORTSTART
SUBROUTINE DINTERP3DZ(data3d, out2d, zdata, levels, nx, ny, nz, nlev, missingval)
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: out2d

    INTEGER, INTENT(IN) :: nx, ny, nz, nlev
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) ::  data3d
    REAL(KIND=8), DIMENSION(nx,ny,nlev), INTENT(OUT) :: out2d
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: zdata
    REAL(KIND=8), DIMENSION(nlev), INTENT(IN) :: levels
    REAL(KIND=8), INTENT(IN) :: missingval

! NCLEND

    INTEGER :: i,j,kp,ip,im,lev
    LOGICAL :: dointerp
    REAL(KIND=8) :: w1,w2,desiredloc

    ! does vertical coordinate increase or decrease with increasing k?
    ! set offset appropriately

    ip = 0
    im = 1
    IF (zdata(1,1,1) .GT. zdata(1,1,nz)) THEN
        ip = 1
        im = 0
    END IF

    !$OMP PARALLEL DO COLLAPSE(3) PRIVATE(i,j,lev,kp,dointerp,w1,w2,desiredloc) &
    !$OMP FIRSTPRIVATE(ip,im) SCHEDULE(runtime)
    DO lev = 1,nlev
        DO i = 1,nx
            DO j = 1,ny
                ! Initialize to missing.  Was initially hard-coded to -999999.
                out2d(i,j,lev) = missingval
                dointerp = .FALSE.
                kp = nz
                desiredloc = levels(lev)

                DO WHILE ((.NOT. dointerp) .AND. (kp >= 2))
                    IF (((zdata(i,j,kp-im) < desiredloc) .AND. (zdata(i,j,kp-ip) > desiredloc))) THEN
                        w2 = (desiredloc - zdata(i,j,kp-im))/(zdata(i,j,kp-ip) - zdata(i,j,kp-im))
                        w1 = 1.D0 - w2
                        out2d(i,j,lev) = w1*data3d(i,j,kp-im) + w2*data3d(i,j,kp-ip)
                        dointerp = .TRUE.
                    END IF
                    kp = kp - 1
                END DO
            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DINTERP3DZ


! NCLFORTSTART
SUBROUTINE DINTERP3DZ_2DLEV(data3d, out2d, zdata, levs2d, nx, ny, nz, missingval)
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: out2d

    INTEGER, INTENT(IN) :: nx, ny, nz
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) ::  data3d
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(OUT) :: out2d
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: zdata
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(IN) :: levs2d
    REAL(KIND=8), INTENT(IN) :: missingval

! NCLEND

    INTEGER :: i,j,kp,ip,im
    LOGICAL :: dointerp
    REAL(KIND=8) :: w1,w2,desiredloc

    ! does vertical coordinate increase or decrease with increasing k?
    ! set offset appropriately

    ip = 0
    im = 1
    IF (zdata(1,1,1) .GT. zdata(1,1,nz)) THEN
        ip = 1
        im = 0
    END IF

    !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(i,j,kp,dointerp,w1,w2,desiredloc) &
    !$OMP FIRSTPRIVATE(ip,im) SCHEDULE(runtime)
    DO i = 1,nx
        DO j = 1,ny
            ! Initialize to missing.  Was initially hard-coded to -999999.
            out2d(i,j) = missingval
            dointerp = .FALSE.
            kp = nz
            desiredloc = levs2d(i,j)

            DO WHILE ((.NOT. dointerp) .AND. (kp >= 2))
                IF (((zdata(i,j,kp-im) < desiredloc) .AND. (zdata(i,j,kp-ip) > desiredloc))) THEN
                    w2 = (desiredloc - zdata(i,j,kp-im))/(zdata(i,j,kp-ip) - zdata(i,j,kp-im))
                    w1 = 1.D0 - w2
                    out2d(i,j) = w1*data3d(i,j,kp-im) + w2*data3d(i,j,kp-ip)
                    dointerp = .TRUE.
                END IF
                kp = kp - 1
            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DINTERP3DZ_2DLEV

! PORT DZSTAG HERE

! NCLFORTSTART
SUBROUTINE DZSTAG(znew, nx, ny, nz, z, nxz, nyz ,nzz, terrain)
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: znew

    INTEGER, INTENT(IN) :: nx, ny, nz, nxz, nyz, nzz
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(OUT) :: znew
    REAL(KIND=8), DIMENSION(nxz,nyz,nzz), INTENT(IN) :: z
    REAL(KIND=8), DIMENSION(nxz,nyz), INTENT(IN) :: terrain
! NCLEND

    INTEGER :: i,j,k,ii,im1,jj,jm1

    ! check for u, v, or w (x,y,or z) staggering
    ! for x and y stag, avg z to x, y, point
    IF (nx .GT. nxz) THEN
        DO k = 1,nz
            DO j = 1,ny
                DO i = 1,nx
                    ii = MIN(i,nxz)
                    im1 = MAX(i-1,1)
                    znew(i,j,k) = 0.5D0*(z(ii,j,k) + z(im1,j,k))
                END DO
            END DO
        END DO

    ELSE IF (ny .GT. nyz) THEN
        DO k = 1,nz
            DO j = 1,NY
                jj = MIN(j,nyz)
                jm1 = MAX(j-1,1)
                DO i = 1,nx
                    znew(i,j,k) = 0.5D0*(z(i,jj,k) + z(i,jm1,k))
                END DO
            END DO
        END DO

    ! w (z) staggering
    ELSE IF (nz .GT. nzz) THEN
        DO j = 1,ny
            DO i = 1,nx
                znew(i,j,1) = terrain(i,j)
            END DO
        END DO

        DO k = 2,nz
            DO j = 1,ny
                DO i = 1,nx
                    znew(i,j,k) = znew(i,j,k-1) + 2.D0*(z(i,j,k-1) - znew(i,j,k-1))
                END DO
            END DO
        END DO

    END IF

    RETURN

    END SUBROUTINE DZSTAG

! NCLFORTSTART
SUBROUTINE DINTERP2DXY(v3d, v2d, xy, nx, ny, nz, nxy)

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: v2d

    INTEGER, INTENT(IN) :: nx, ny, nz, nxy
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: v3d
    REAL(KIND=8), DIMENSION(nxy,nz), INTENT(OUT) :: v2d
    REAL(KIND=8), DIMENSION(2,nxy), INTENT(IN) :: xy

! NCLEND

    INTEGER :: i, j, k, ij
    REAL(KIND=8) :: w11, w12, w21, w22, wx, wy

    !$OMP PARALLEL DO PRIVATE(i,j,k,ij,w11,w12,w21,w22,wx,wy) &
    !$OMP SCHEDULE(runtime)
    DO ij = 1,nxy
        i = MAX(1,MIN(nx-1,INT(xy(1,ij)+1)))
        j = MAX(1,MIN(ny-1,INT(xy(2,ij)+1)))
        wx = DBLE(i+1) - (xy(1,ij)+1)
        wy = DBLE(j+1) - (xy(2,ij)+1)
        w11 = wx*wy
        w21 = (1.D0-wx)*wy
        w12 = wx*(1.D0-wy)
        w22 = (1.D0-wx)* (1.D0-wy)
        DO k = 1,nz
            v2d(ij,k) = w11*v3d(i,j,k) + w21*v3d(i+1,j,k) + &
            w12*v3d(i,j+1,k) + w22*v3d(i+1,j+1,k)
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DINTERP2DXY


! NCLFORTSTART
SUBROUTINE DINTERP1D(v_in, v_out, z_in, z_out, vmsg, nz_in, nz_out)

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: v_out

    INTEGER, INTENT(IN) :: nz_in, nz_out
    REAL(KIND=8), DIMENSION(nz_in), INTENT(IN) :: v_in, z_in
    REAL(KIND=8), DIMENSION(nz_out), INTENT(IN) :: z_out
    REAL(KIND=8), DIMENSION(nz_out), INTENT(OUT) :: v_out
    REAL(KIND=8), INTENT(IN) :: vmsg

! NCLEND

    INTEGER :: kp,k,im,ip
    LOGICAL :: interp
    REAL(KIND=8) :: height,w1,w2

    ! does vertical coordinate increase of decrease with increasing k?
    ! set offset appropriately

    ip = 0
    im = 1
    IF (z_in(1) .GT. z_in(nz_in)) THEN
        ip = 1
        im = 0
    END IF

    !$OMP PARALLEL DO PRIVATE(kp, k, interp, height, w1, w2) &
    !$OMP FIRSTPRIVATE(ip, im) SCHEDULE(runtime)
    DO k = 1,nz_out
        v_out(k) = vmsg

        interp = .FALSE.
        kp = nz_in
        height = z_out(k)

        DO WHILE ((.NOT. interp) .AND. (kp .GE. 2))
            IF (((z_in(kp-im) .LE. height) .AND. (z_in(kp-ip) .GT. height))) THEN
                w2 = (height - z_in(kp-im))/(z_in(kp-ip) - z_in(kp-im))
                w1 = 1.D0 - w2
                v_out(k) = w1*v_in(kp-im) + w2*v_in(kp-ip)
                interp = .TRUE.
            END IF
            kp = kp - 1
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DINTERP1D

! This routine assumes
!    index order is (i,j,k)
!    wrf staggering
!
!    units: pressure (Pa), temperature(K), height (m), mixing ratio
!     (kg kg{-1}) availability of 3d p, t, and qv; 2d terrain; 1d
! half-level zeta string
!    output units of SLP are Pa, but you should divide that by 100 for the
!          weather weenies.
!    virtual effects are included
!

! NCLFORTSTART
SUBROUTINE DCOMPUTESEAPRS(nx, ny, nz, z, t, p, q, sea_level_pressure, &
                          t_sea_level, t_surf, level, errstat, errmsg)
    USE wrf_constants, ONLY : ALGERR, RD, G, USSALR

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: sea_level_pressure

    !     Estimate sea level pressure.
    INTEGER, INTENT(IN) :: nx, ny, nz
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: z
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: t, p, q
    !     The output is the 2d sea level pressure.
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(OUT) :: sea_level_pressure
    INTEGER, DIMENSION(nx,ny), INTENT(INOUT) ::  level
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(INOUT) :: t_surf, t_sea_level
    INTEGER, INTENT(INOUT) :: errstat
    CHARACTER(LEN=*), INTENT(INOUT) :: errmsg

! NCLFORTEND

    !     Some required physical constants:

    !REAL(KIND=8), PARAMETER :: R=287.04D0, G=9.81D0, GAMMA=0.0065D0

    !     Specific constants for assumptions made in this routine:
    REAL(KIND=8), PARAMETER :: TC=273.16D0+17.5D0, PCONST=10000

    LOGICAL, PARAMETER :: ridiculous_mm5_test=.TRUE.
    !      PARAMETER (ridiculous_mm5_test = .FALSE.)

    !     Local variables:

    INTEGER :: i, j, k
    INTEGER :: klo, khi
    INTEGER :: errcnt, bad_i, bad_j

    REAL(KIND=8) :: bad_sfp
    REAL(KIND=8) :: plo, phi, tlo, thi, zlo, zhi
    REAL(KIND=8) :: p_at_pconst, t_at_pconst, z_at_pconst
    !REAL(KIND=8) :: z_half_lowest

    LOGICAL :: l1, l2, l3, found

    !  Find least zeta level that is PCONST Pa above the surface.  We
    !  later use this level to extrapolate a surface pressure and
    !  temperature, which is supposed to reduce the effect of the diurnal
    !  heating cycle in the pressure field.

    errstat = 0
    errcnt = 0
    bad_i = -1
    bad_j = -1
    bad_sfp = -1

    !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(i,j,k,found) REDUCTION(+:errcnt) &
    !$OMP SCHEDULE(runtime)
    DO j = 1,ny
        DO i = 1,nx
            level(i,j) = -1

            k = 1
            found = .FALSE.
            DO WHILE ((.NOT. found) .AND. (k <= nz))
                IF (p(i,j,k) < p(i,j,1)-PCONST) THEN
                    level(i,j) = k
                    found = .TRUE.
                END IF
                k = k + 1
            END DO

            IF (level(i,j) == -1) THEN
                errcnt = errcnt + 1
                !$OMP CRITICAL
                ! Only do this the first time
                IF (bad_i .EQ. -1) THEN
                    bad_i = i
                    bad_j = j
                    bad_sfp = p(i,j,1) / 100.
                END IF
                !$OMP END CRITICAL
            END IF
        END DO
    END DO
    !$OMP END PARALLEL DO

    IF (errcnt > 0) THEN
        errstat = ALGERR
        WRITE(errmsg,*) "Error in finding 100 hPa up.  i=", bad_i, "j=", bad_j, "sfc_p=", bad_sfp
        RETURN
    END IF

    !     Get temperature PCONST Pa above surface.  Use this to extrapolate
    !     the temperature at the surface and down to sea level.
    !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(i,j,klo,khi,plo, &
    !$OMP phi,tlo,thi,zlo,zhi,p_at_pconst,t_at_pconst,z_at_pconst) &
    !$OMP REDUCTION(+:errcnt) SCHEDULE(runtime)
    DO j = 1,ny
        DO i = 1,nx

            klo = MAX(level(i,j)-1, 1)
            khi = MIN(klo+1, nz-1)

            IF (klo == khi) THEN
                errcnt = errcnt + 1
                !$OMP CRITICAL
                IF (bad_i .EQ. -1) THEN
                    bad_i = i
                    bad_j = j
                END IF
                !$OMP END CRITICAL
            END IF

            plo = p(i,j,klo)
            phi = p(i,j,khi)
            tlo = t(i,j,klo)*(1.D0 + 0.608D0*q(i,j,klo))
            thi = t(i,j,khi)*(1.D0 + 0.608D0*q(i,j,khi))
            zlo = z(i,j,klo)
            zhi = z(i,j,khi)
            p_at_pconst = p(i,j,1) - PCONST
            t_at_pconst = thi - (thi-tlo)*LOG(p_at_pconst/phi)*LOG(plo/phi)
            z_at_pconst = zhi - (zhi-zlo)*LOG(p_at_pconst/phi)*LOG(plo/phi)
            !
            t_surf(i,j) = t_at_pconst * (p(i,j,1)/p_at_pconst)**(USSALR*RD/G)
            t_sea_level(i,j) = t_at_pconst + USSALR*z_at_pconst
        END DO
    END DO
    !$OMP END PARALLEL DO

    IF (errcnt > 0) THEN
        errstat = ALGERR
        WRITE(errmsg,*) "Error trapping levels at i=", bad_i, "j=", bad_j
        RETURN
    END IF

    ! If we follow a traditional computation, there is a correction to the
    ! sea level temperature if both the surface and sea level
    ! temperatures are *too* hot.

    IF (ridiculous_mm5_test) THEN
        !$OMP PARALLEL DO COLLAPSE(2) PRIVATE(l1,l2,l3) SCHEDULE(runtime)
        DO j = 1,ny
            DO i = 1,nx
                l1 = t_sea_level(i,j) < TC
                l2 = t_surf(i,j) <= TC
                l3 = .NOT. l1
                IF (l2 .AND. l3) THEN
                    t_sea_level(i,j) = TC
                ELSE
                    t_sea_level(i,j) = TC - 0.005D0*(t_surf(i,j)-TC)**2
                END IF
            END DO
        END DO
        !$OMP END PARALLEL DO
    END IF

    !     The grand finale: ta da!
    !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(runtime)
    DO j = 1,ny
        DO i = 1,nx
            !z_half_lowest = z(i,j,1)

    ! Convert to hPa in this step, by multiplying by 0.01. The original
    ! Fortran routine didn't do this, but the NCL script that called it
    ! did, so we moved it here.
            sea_level_pressure(i,j) = 0.01*(p(i,j,1)*EXP((2.D0*G*z(i,j,1))/&
                (RD*(t_sea_level(i,j) + t_surf(i,j)))))
        END DO
    END DO
    !$OMP END PARALLEL DO

    !     PRINT *,'sea pres input at weird location i=20,j=1,k=1'
    !     PRINT *,'t=',t(20,1,1),t(20,2,1),t(20,3,1)
    !     PRINT *,'z=',z(20,1,1),z(20,2,1),z(20,3,1)
    !     PRINT *,'p=',p(20,1,1),p(20,2,1),p(20,3,1)
    !     PRINT *,'slp=',sea_level_pressure(20,1),
    !    *         sea_level_pressure(20,2),sea_level_pressure(20,3)

    RETURN

END SUBROUTINE DCOMPUTESEAPRS


! Double precision version. If you make a change here, you
! must make the same change below to filter2d.

! NCLFORTSTART
SUBROUTINE DFILTER2D(a, b, nx, ny, it, missing, cenweight)

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: a

    INTEGER, INTENT(IN) :: nx, ny, it
    REAL(KIND=8), DIMENSION(nx, ny), INTENT(INOUT) :: a
    REAL(KIND=8), INTENT(IN) :: missing, cenweight
    REAL(KIND=8), DIMENSION(nx, ny), INTENT(INOUT) :: b

! NCLEND

    INTEGER :: i, j, iter
    REAL(KIND=8) :: cenmult, coef

    cenmult = (cenweight) / 2.
    coef = 1.0 / (4. + cenweight)

    DO iter=1,it
        !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(runtime)
        DO j=1,ny
            DO i = 1,nx
                b(i,j) = a(i,j)
            END DO
        END DO
        !$OMP END PARALLEL DO

        !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(runtime)
        DO j=2,ny-1
            DO i=2,nx-1
                IF (b(i,j-1) .EQ. missing .OR. b(i,j) .EQ. missing .OR. &
                    b(i,j+1) .EQ. missing) THEN
                    a(i,j) = a(i,j)
                ELSE
                    a(i,j) = coef*(b(i,j-1) + cenmult*b(i,j) + b(i,j+1))
                END IF
            END DO
        END DO
        !$OMP END PARALLEL DO

        !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(runtime)
        DO j=2,ny-1
            DO i=2,nx-1
                IF (b(i-1,j) .EQ. missing .OR. b(i,j) .EQ. missing .OR. &
                    b(i+1,j) .EQ. missing) THEN
                    a(i,j) = a(i,j)
                ELSE
                    a(i,j) = a(i,j) + coef*(b(i-1,j) + cenmult*b(i,j) + b(i+1,j))
                END IF
            END DO
        END DO
        !$OMP END PARALLEL DO
    !        do j=1,ny
    !        do i=1,nx
    !          b(i,j) = a(i,j)
    !        enddo
    !        enddo
    !        do j=2,ny-1
    !        do i=1,nx
    !          a(i,j) = a(i,j) - .99*coef*(b(i,j-1)-2*b(i,j)+b(i,j+1))
    !        enddo
    !        enddo
    !        do j=1,ny
    !        do i=2,nx-1
    !          a(i,j) = a(i,j) - .99*coef*(b(i-1,j)-2*b(i,j)+b(i+1,j))
    !        enddo
    !        enddo
    END DO

    RETURN

END SUBROUTINE DFILTER2D

! Single precision version. If you make a change here, you
! must make the same change below to dfilter2d.

! NCLFORTSTART
SUBROUTINE FILTER2D(a, b, nx, ny, it, missing, cenweight)
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: a

    INTEGER, INTENT(IN) :: nx, ny, it
    REAL(KIND=4), DIMENSION(nx, ny), INTENT(INOUT) :: a
    REAL(KIND=4), INTENT(IN) :: missing, cenweight
    REAL(KIND=4), DIMENSION(nx, ny), INTENT(INOUT) :: b

! NCLEND

    !REAL(KIND=8), PARAMETER :: COEF = .125
    INTEGER :: i, j, iter
    REAL(KIND=8) :: cenmult, coef

    cenmult = (cenweight) / 2.
    coef = 1.0 / (4. + cenweight)

    !$OMP PARALLEL

    DO iter=1,it
        !$OMP DO COLLAPSE(2) SCHEDULE(runtime)
        DO j=1,ny
            DO i = 1,nx
                b(i,j) = a(i,j)
            END DO
        END DO
        !$OMP END DO

        !$OMP DO COLLAPSE(2) SCHEDULE(runtime)
        DO j=2,ny-1
            DO i=2,nx-1
                IF (b(i,j-1) .EQ. missing .OR. b(i,j) .EQ. missing .OR. &
                    b(i,j+1) .EQ. missing) THEN
                    a(i,j) = a(i,j)
                ELSE
                    a(i,j) = coef*(b(i,j-1) + cenmult*b(i,j) + b(i,j+1))
                END IF
            END DO
        END DO
        !$OMP END DO

        !$OMP DO COLLAPSE(2) SCHEDULE(runtime)
        DO j=2,ny-1
            DO i=2,nx-1
                IF (b(i-1,j) .EQ. missing .OR. b(i,j) .EQ. missing .OR. &
                    b(i+1,j) .EQ. missing) THEN
                    a(i,j) = a(i,j)
                ELSE
                    a(i,j) = a(i,j) + coef*(b(i-1,j) + cenmult*b(i,j) + b(i+1,j))
                END IF
            END DO
        END DO
        !$OMP END DO
    !        do j=1,ny
    !        do i=1,nx
    !          b(i,j) = a(i,j)
    !        enddo
    !        enddo
    !        do j=2,ny-1
    !        do i=1,nx
    !          a(i,j) = a(i,j) - .99*coef*(b(i,j-1)-2*b(i,j)+b(i,j+1))
    !        enddo
    !        enddo
    !        do j=1,ny
    !        do i=2,nx-1
    !          a(i,j) = a(i,j) - .99*coef*(b(i-1,j)-2*b(i,j)+b(i+1,j))
    !        enddo
    !        enddo
    END DO

    !$OMP END PARALLEL

    RETURN

END SUBROUTINE FILTER2D


! NCLFORTSTART
SUBROUTINE DCOMPUTERH(qv, p, t, rh, nx)
    USE wrf_constants, ONLY : EZERO, ESLCON1, ESLCON2, CELKEL, RD, RV, EPS

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: rh

    INTEGER, INTENT(IN) :: nx
    REAL(KIND=8), DIMENSION(nx), INTENT(IN) :: qv, p, t
    REAL(KIND=8), DIMENSION(nx), INTENT(OUT) :: rh

! NCLEND

    INTEGER :: i
    REAL(KIND=8) :: qvs,es,pressure,temperature

    !$OMP PARALLEL DO PRIVATE(qvs, es, pressure, temperature) SCHEDULE(runtime)
    DO i = 1,nx
        pressure = p(i)
        temperature = t(i)
        ! es  = 1000.*svp1*
        es = EZERO*EXP(ESLCON1*(temperature - CELKEL)/(temperature - ESLCON2))
        ! qvs = ep_2*es/(pressure-es)
        qvs = EPS*es/(0.01D0*pressure - (1.D0 - EPS)*es)
        ! rh = 100*MAX(1., qv(i)/qvs)
        ! rh(i) = 100.*qv(i)/qvs
        rh(i) = 100.D0*MAX(MIN(qv(i)/qvs, 1.0D0), 0.0D0)
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DCOMPUTERH


! NCLFORTSTART
SUBROUTINE DGETIJLATLONG(lat_array, long_array, lat, longitude, ii, jj, nx, ny, imsg)
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: ii,jj

    INTEGER, INTENT(IN) :: nx, ny, imsg
    INTEGER, INTENT(OUT) :: ii, jj
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(IN) :: lat_array, long_array
    REAL(KIND=8) :: lat, longitude
! NCLEND

    REAL(KIND=8) :: longd,latd
    INTEGER :: i,j
    REAL(KIND=8) :: ir,jr
    REAL(KIND=8) :: dist_min,dist

    ! init to missing. was hard-coded to -999 initially.
    ir = imsg
    jr = imsg

    dist_min = 1.D+20
    DO j = 1,ny
        DO i = 1,nx
            latd = (lat_array(i,j) - lat)**2
            longd = (long_array(i,j) - longitude)**2
            ! longd = MIN((long_array(i,j)-longitude)**2, &
            !               (long_array(i,j)+longitude)**2)
            dist = SQRT(latd + longd)
            IF (dist_min .GT. dist) THEN
                dist_min = dist
                ir = DBLE(i)
                jr = DBLE(j)
            END IF
        END DO
    END DO

    ! The original version of this routine returned IR and JR. But, then
    ! the NCL script that called this routine was converting IR and JR
    ! to integer, so why not just return II and JJ?

    ! Also, I'm subtracing 1 here, because it will be returned to NCL
    ! script which has 0-based indexing.

    IF (ir .NE. imsg .AND. jr .NE. imsg) THEN
        ii = NINT(ir) - 1
        jj = NINT(jr) - 1
    ELSE
        ii = imsg
        jj = imsg
    END IF

    ! we will just return the nearest point at present

    RETURN

END SUBROUTINE DGETIJLATLONG

! You need to modify the C-WRAPPER in NCL for this to work

! NCLFORTSTART
SUBROUTINE DCOMPUTEUVMET(u, v, uvmet, longca,longcb,flong,flat, &
                        cen_long, cone, rpd, nx, ny, nxp1, nyp1, &
                        istag, is_msg_val, umsg, vmsg, uvmetmsg)
    IMPLICIT NONE

    ! ISTAG should be 0 if the U,V grids are not staggered.
    ! That is, NY = NYP1 and NX = NXP1.

    !f2py threadsafe
    !f2py intent(in,out) :: uvmet

    INTEGER,INTENT(IN) :: nx, ny, nxp1, nyp1, istag
    LOGICAL,INTENT(IN) :: is_msg_val
    REAL(KIND=8), DIMENSION(nxp1,ny), INTENT(IN):: u
    REAL(KIND=8), DIMENSION(nx,nyp1), INTENT(IN) :: v
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(IN) :: flong
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(IN) :: flat
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(INOUT) :: longca
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(INOUT) :: longcb
    REAL(KIND=8), INTENT(IN) :: cen_long, cone, rpd
    REAL(KIND=8), INTENT(IN) :: umsg, vmsg, uvmetmsg
    REAL(KIND=8), DIMENSION(nx,ny,2), INTENT(OUT) :: uvmet


! NCLEND

    INTEGER :: i,j
    !REAL(KIND=8) :: uk, vk

    ! msg stands for missing value in this code
    ! WRITE (6,FMT=*) ' in compute_uvmet ',NX,NY,NXP1,NYP1,ISTAG

    !$OMP PARALLEL

    !$OMP DO COLLAPSE(2) SCHEDULE(runtime)
    DO j = 1,ny
        DO i = 1,nx

            longca(i,j) = flong(i,j) - cen_long
            IF (longca(i,j).GT.180.D0) THEN
                longca(i,j) = longca(i,j) - 360.D0
            END IF
            IF (longca(i,j).LT.-180.D0) THEN
                longca(i,j) = longca(i,j) + 360.D0
            END IF
            IF (flat(i,j).LT.0.D0) THEN
                longcb(i,j) = -longca(i,j)*cone*rpd
            ELSE
                longcb(i,j) = longca(i,j)*cone*rpd
            END IF

            longca(i,j) = COS(longcb(i,j))
            longcb(i,j) = SIN(longcb(i,j))

        END DO
    END DO
    !$OMP END DO

    ! Note:  Intentionally removed as many IF statements as possible from loops
    ! to improve vectorization.

    IF (istag .EQ. 0) THEN ! Not staggered
        IF (.NOT. is_msg_val) THEN ! No missing values used
            !$OMP DO COLLAPSE(2) SCHEDULE(runtime)
            DO j = 1,ny
                DO i = 1,nx
                    uvmet(i,j,1) = v(i,j)*longcb(i,j) + u(i,j)*longca(i,j)
                    uvmet(i,j,2) = v(i,j)*longca(i,j) - u(i,j)*longcb(i,j)
                END DO
            END DO
            !$OMP END DO
        ELSE ! Missing values used
            !$OMP DO COLLAPSE(2) SCHEDULE(runtime)
            DO j = 1,ny
                DO i = 1,nx
                    IF ((u(i,j) .NE. umsg .AND. v(i,j) .NE. vmsg)) THEN
                        uvmet(i,j,1) = v(i,j)*longcb(i,j) + u(i,j)*longca(i,j)
                        uvmet(i,j,2) = v(i,j)*longca(i,j) - u(i,j)*longcb(i,j)
                    ELSE
                        uvmet(i,j,1) = uvmetmsg
                        uvmet(i,j,2) = uvmetmsg
                    END IF
                END DO
            END DO
            !$OMP END DO
        END IF
    ELSE ! Staggered
        IF (.NOT. is_msg_val) THEN ! No missing values used
            !$OMP DO COLLAPSE(2) SCHEDULE(runtime)
            DO j = 1,ny
                DO i = 1,nx
                    ! This is the more readable version.
                    !uk = 0.5D0*(u(i,j) + u(i+1,j))
                    !vk = 0.5D0*(v(i,j) + v(i,j+1))
                    !uvmet(i,j,1) = vk*longcb(i,j) + uk*longca(i,j)
                    !uvmet(i,j,2) = vk*longca(i,j) - uk*longcb(i,j)

                    uvmet(i,j,1) = (0.5D0*(v(i,j) + v(i,j+1)))*longcb(i,j) + &
                                   (0.5D0*(u(i,j) + u(i+1,j)))*longca(i,j)
                    uvmet(i,j,2) = (0.5D0*(v(i,j) + v(i,j+1)))*longca(i,j) - &
                                   (0.5D0*(u(i,j) + u(i+1,j)))*longcb(i,j)

                END DO
            END DO
            !$OMP END DO
        ELSE ! Missing values used
            !$OMP DO COLLAPSE(2) SCHEDULE(runtime)
            DO j = 1,ny
                DO i = 1,nx
                    IF (u(i,j) .NE. umsg .AND. v(i,j) .NE. vmsg .AND. u(i+1,j) .NE. umsg .AND. v(i,j+1) .NE. vmsg) THEN
                        ! This is the more readable version.
                        !uk = 0.5D0*(u(i,j) + u(i+1,j))
                        !vk = 0.5D0*(v(i,j) + v(i,j+1))
                        !uvmet(i,j,1) = vk*longcb(i,j) + uk*longca(i,j)
                        !uvmet(i,j,2) = vk*longca(i,j) - uk*longcb(i,j)

                        uvmet(i,j,1) = (0.5D0*(v(i,j) + v(i,j+1)))*longcb(i,j) + &
                                       (0.5D0*(u(i,j) + u(i+1,j)))*longca(i,j)
                        uvmet(i,j,2) = (0.5D0*(v(i,j) + v(i,j+1)))*longca(i,j) - &
                                       (0.5D0*(u(i,j) + u(i+1,j)))*longcb(i,j)
                    ELSE
                        uvmet(i,j,1) = uvmetmsg
                        uvmet(i,j,2) = uvmetmsg
                    END IF
                END DO
            END DO
            !$OMP END DO
        END IF
    END IF

    !$OMP END PARALLEL

    RETURN

END SUBROUTINE DCOMPUTEUVMET




! This was originally a routine that took 2D input arrays. Since
! the NCL C wrapper routine can handle multiple dimensions, it's
! not necessary to have anything bigger than 1D here.

! NCLFORTSTART
SUBROUTINE DCOMPUTETD(td, pressure, qv_in, nx)
    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: td

    INTEGER, INTENT(IN) :: nx
    REAL(KIND=8), DIMENSION(nx), INTENT(IN) :: pressure
    REAL(KIND=8), DIMENSION(nx), INTENT(IN) :: qv_in
    REAL(KIND=8), DIMENSION(nx), INTENT(OUT) :: td

! NCLEND

    REAL(KIND=8) :: qv,tdc

    INTEGER :: i

    !$OMP PARALLEL DO PRIVATE(i,qv,tdc) SCHEDULE(runtime)
    DO i = 1,nx
        qv = MAX(qv_in(i), 0.D0)
         ! vapor pressure
         tdc = qv*pressure(i)/(.622D0 + qv)

         ! avoid problems near zero
         tdc = MAX(tdc, 0.001D0)
         td(i) = (243.5D0*LOG(tdc) - 440.8D0)/(19.48D0 - LOG(tdc))
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DCOMPUTETD

! NCLFORTSTART
SUBROUTINE DCOMPUTEICLW(iclw, pressure, qc_in, nx, ny, nz)
    USE wrf_constants, ONLY : G

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: iclw

    INTEGER, INTENT(IN) :: nx,ny,nz
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: pressure
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: qc_in
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(OUT) :: iclw

! NCLEND

    REAL(KIND=8) :: qclw, dp
    REAL(KIND=8), PARAMETER :: GG = 1000.D0/G
    INTEGER i,j,k

    iclw = 0

    DO j = 3,ny - 2
        DO i = 3,nx - 2
            DO k = 1,nz
                qclw = MAX(qc_in(i,j,k), 0.D0)
                IF (k.EQ.1) THEN
                    dp = pressure(i,j,k-1) - pressure(i,j,k)
                ELSE IF (k.EQ.nz) then
                    dp = pressure(i,j,k) - pressure(i,j,k+1)
                ELSE
                    dp = (pressure(i,j,k-1) - pressure(i,j,k+1))/2.D0
                END IF
                iclw(i,j) = iclw(i,j) + qclw*dp*GG
            END DO
        END DO
    END DO

    RETURN

END SUBROUTINE DCOMPUTEICLW

SUBROUTINE testfunc(a, b, c, nx, ny, nz, errstat, errmsg)
    USE wrf_constants, ONLY : ALGERR
    IMPLICIT NONE

    !threadsafe
    !f2py intent(in,out) :: b

    INTEGER, INTENT(IN) :: nx, ny, nz

    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: a
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(OUT) :: b
    CHARACTER(LEN=*), INTENT(IN) :: c
    INTEGER, INTENT(INOUT) :: errstat
    REAL(KIND=8), PARAMETER :: blah=123.45
    CHARACTER(LEN=*), INTENT(INOUT) :: errmsg

    INTEGER :: i,j,k

    DO k=1,nz
        DO j=1,ny
            DO i=1,nx
                b(i,j,k) = a(i,j,k)
            END DO
        END DO
    END DO

    errstat = ALGERR
    WRITE(errmsg, *) c(1:20), blah

    RETURN

END SUBROUTINE testfunc

!NCLFORTSTART
SUBROUTINE DCOMPUTEABSVORT(av, u, v, msfu, msfv, msft, cor, dx, dy, nx, ny, nz,&
                          nxp1, nyp1)

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: av

    INTEGER, INTENT(IN) :: nx, ny, nz, nxp1, nyp1
    REAL(KIND=8), DIMENSION(nxp1,ny,nz), INTENT(IN) :: u
    REAL(KIND=8), DIMENSION(nx,nyp1,nz), INTENT(IN) :: v
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(OUT) :: av
    REAL(KIND=8), DIMENSION(nxp1,ny), INTENT(IN):: msfu
    REAL(KIND=8), DIMENSION(nx,nyp1), INTENT(IN) :: msfv
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(IN) :: msft
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(IN) :: cor
    REAL(KIND=8) :: dx, dy

!NCLEND

    INTEGER :: jp1, jm1, ip1, im1, i, j, k
    REAL(KIND=8) :: dsy, dsx, dudy, dvdx, avort
    REAL(KIND=8) :: mm

    !$OMP PARALLEL DO COLLAPSE(3) PRIVATE(i, j, k, jp1, jm1, ip1, im1, &
    !$OMP dsx, dsy, mm, dudy, dvdx, avort) SCHEDULE(runtime)
    DO k = 1,nz
        DO j = 1,ny
            DO i = 1,nx
                jp1 = MIN(j+1, ny)
                jm1 = MAX(j-1, 1)
                ip1 = MIN(i+1, nx)
                im1 = MAX(i-1, 1)
                dsx = (ip1 - im1) * dx
                dsy = (jp1 - jm1) * dy
                mm = msft(i,j)*msft(i,j)
                dudy = 0.5D0*(u(i,jp1,k)/msfu(i,jp1) + u(i+1,jp1,k)/msfu(i+1,jp1) - &
                     u(i,jm1,k)/msfu(i,jm1) - u(i+1,jm1,k)/msfu(i+1,jm1))/dsy*mm
                dvdx = 0.5D0*(v(ip1,j,k)/msfv(ip1,j) + v(ip1,j+1,k)/msfv(ip1,j+1) - &
                     v(im1,j,k)/msfv(im1,j) - v(im1,j+1,k)/msfv(im1,j+1))/dsx*mm
                avort = dvdx - dudy + cor(i,j)
                av(i,j,k) = avort*1.D5

            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DCOMPUTEABSVORT


!NCLFORTSTART
SUBROUTINE DCOMPUTEPV(pv, u, v, theta, prs, msfu, msfv, msft, cor, dx, dy, nx, &
                      ny, nz, nxp1, nyp1)
    USE wrf_constants, ONLY : G

    IMPLICIT NONE

    !f2py threadsafe
    !f2py intent(in,out) :: pv

    INTEGER,INTENT(IN) :: nx, ny, nz, nxp1, nyp1
    REAL(KIND=8), DIMENSION(nxp1,ny,nz), INTENT(IN) :: u
    REAL(KIND=8), DIMENSION(nx,nyp1,nz), INTENT(IN) :: v
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: prs
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(IN) :: theta
    REAL(KIND=8), DIMENSION(nx,ny,nz), INTENT(OUT) :: pv
    REAL(KIND=8), DIMENSION(nxp1,ny), INTENT(IN) ::  msfu
    REAL(KIND=8), DIMENSION(nx,nyp1), INTENT(IN) :: msfv
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(IN) :: msft
    REAL(KIND=8), DIMENSION(nx,ny), INTENT(IN) :: cor
    REAL(KIND=8) :: dx,dy

!NCLEND

    INTEGER :: kp1, km1, jp1, jm1, ip1, im1, i, j, k
    REAL(KIND=8) :: dsy, dsx, dp, dudy, dvdx, dudp, dvdp, dthdp, avort
    REAL(KIND=8) :: dthdx, dthdy, mm

    !$OMP PARALLEL DO COLLAPSE(3) PRIVATE(i, j, k, kp1, km1, jp1, jm1, ip1, &
    !$OMP im1, dsx, dsy, mm, dudy, dvdx, avort, &
    !$OMP dp, dudp, dvdp, dthdp, dthdx, dthdy) SCHEDULE(runtime)
    DO k = 1,nz
        DO J = 1,ny
            DO i = 1,nx
                kp1 = MIN(k+1, nz)
                km1 = MAX(k-1, 1)
                jp1 = MIN(j+1, ny)
                jm1 = MAX(j-1, 1)
                ip1 = MIN(i+1, nx)
                im1 = MAX(i-1, 1)

                dsx = (ip1 - im1)*dx
                dsy = (jp1 - jm1)*dy
                mm = msft(i,j)*msft(i,j)

                dudy = 0.5D0*(u(i,jp1,k)/msfu(i,jp1) + u(i+1,jp1,k)/msfu(i+1,jp1) - &
                       u(i,jm1,k)/msfu(i,jm1) - u(i+1,jm1,k)/msfu(i+1,jm1))/dsy*mm
                dvdx = 0.5D0*(v(ip1,j,k)/msfv(ip1,j) + v(ip1,j+1,k)/msfv(ip1,j+1) - &
                       v(im1,j,k)/msfv(im1,j) - v(im1,j+1,k)/msfv(im1,j+1))/dsx*mm
                avort = dvdx - dudy + cor(i,j)
                dp = prs(i,j,kp1) - prs(i,j,km1)
                dudp = 0.5D0*(u(i,j,kp1) + u(i+1,j,kp1) - u(i,j,km1) - u(i+1,j,km1))/dp
                dvdp = 0.5D0*(v(i,j,kp1) + v(i,j+1,kp1) - v(i,j,km1) - v(i,J+1,km1))/dp
                dthdp = (theta(i,j,kp1) - theta(i,j,km1))/dp
                dthdx = (theta(ip1,j,k) - theta(im1,j,k))/dsx*msft(i,j)
                dthdy = (theta(i,jp1,k) - theta(i,jm1,k))/dsy*msft(i,j)
                pv(i,j,k) = -G*(dthdp*avort - dvdp*dthdx + dudp*dthdy)*10000.D0
                pv(i,j,k) = pv(i,j,k)*1.D2
            END DO
        END DO
    END DO
    !$OMP END PARALLEL DO

    RETURN

END SUBROUTINE DCOMPUTEPV

cd ../fortran
CALL gfortran -E ompgen.F90 -cpp -o omp.f90
REM Wildcards not working on Windows for some reason
REM CALL f2py -m _wrffortran -h wrffortran.pyf --overwrite-signature wrf_constants.f90 wrf_testfunc.f90 wrf_user.f90 rip_cape.f90 wrf_cloud_fracf.f90 wrf_fctt.f90 wrf_user_dbz.f90 wrf_relhl.f90 calc_uh.f90 wrf_user_latlon_routines.f90 wrf_pvo.f90 eqthecalc.f90 wrf_rip_phys_routines.f90 wrf_pw.f90 wrf_vinterp.f90 wrf_wind.f90 omp.f90
cd ..

CALL python setup.py clean --all

IF %PROCESSOR_ARCHITECTURE% == AMD64 (
    CALL python setup.py config_fc --f90flags="-O2 -mtune=generic" build --compiler=mingw32 --fcompiler=gnu95       
) ELSE (
    CALL python setup.py config_fc --f90flags="-O2 -mtune=generic -mincoming-stack-boundary=2" build --compiler=mingw32 --fcompiler=gnu95
)

CALL pip install .

#!/bin/bash

cd ../fortran/build_help
ifort -o sizes -qopenmp omp_sizes.f90
python sub_sizes.py

cd ..
ifort ompgen.F90 -qopenmp -fpp -save-temps > /dev/null 2>&1
mv ompgen.i90 omp.f90
#f2py *.f90 -m _wrffortran -h wrffortran.pyf --overwrite-signature
cd ..

python setup.py clean --all
python setup.py config_fc --f90flags="-xHost -mkl -qopenmp" build_ext --rpath="/glade/u/apps/opt/intel/2017u1/compilers_and_libraries/linux/lib/intel64_lin:/glade/u/apps/opt/intel/2017u1/compilers_and_libraries/linux/mkl/lib/intel64_lin" --library-dirs="/glade/u/apps/opt/intel/2017u1/compilers_and_libraries/linux/lib/intel64_lin:/glade/u/apps/opt/intel/2017u1/compilers_and_libraries/linux/mkl/lib/intel64_lin" --libraries="mkl_intel_ilp64 mkl_intel_thread mkl_core iomp5 pthread m dl" build --compiler=intelem --fcompiler=intelem bdist_wheel

#pip install .

cd ../fortran
CALL gfortran -E ompgen.F90 -cpp -o omp.f90
cd ..

CALL python setup.py clean --all

IF %PROCESSOR_ARCHITECTURE% == AMD64 (
    CALL python setup.py config_fc --f90flags="-O2 -mtune=generic" build --compiler=mingw32 --fcompiler=gnu95       
) ELSE (
    CALL python setup.py config_fc --f90flags="-O2 -mtune=generic -mincoming-stack-boundary=2" build --compiler=msvc --fcompiler=gnu95
)
    CALL pip install .

cd ..\fortran\build_help
CALL gfortran -o sizes -fopenmp omp_sizes.f90
CALL python sub_sizes.py

cd ..
CALL gfortran -E ompgen.F90 -cpp -fopenmp -o omp.f90
cd ..

CALL python setup.py clean --all
    
IF %PROCESSOR_ARCHITECTURE% == AMD64 (
    CALL python setup.py config_fc --f90flags="-O2 -mtune=generic -fopenmp" build_ext --libraries="gomp" build --compiler=msvc --fcompiler=gnu95       
) ELSE (
    CALL python setup.py config_fc --f90flags="-O2 -mtune=generic -fopenmp -mincoming-stack-boundary=2" build_ext --libraries="gomp" build --compiler=msvc --fcompiler=gnu95
)

CALL pip install .

#!/bin/bash

unset LDFLAGS

cd ../fortran/build_help
$FC -o sizes -fopenmp omp_sizes.f90
python sub_sizes.py

cd ..
$FC -E ompgen.F90 -fopenmp -cpp -o omp.f90
cd ..

python setup.py clean --all
python setup.py config_fc --f90flags="-mtune=generic -fopenmp" build_ext --libraries="gomp" build
pip install .
